// OptionsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Rootfly.h"
#include "OptionsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptionsDlg dialog


COptionsDlg::COptionsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COptionsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void COptionsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionsDlg)
	DDX_Control(pDX, IDC_OPT_SPIN_WINDOW_ORDER, m_spin_window_order);
	DDX_Control(pDX, IDC_OPT_SPIN_TUBE_ORDER, m_spin_tube_order);
	DDX_Control(pDX, IDC_OPT_SPIN_SESSION_ORDER, m_spin_session_order);
	DDX_Control(pDX, IDC_OPT_SPIN_NAME_ORDER, m_spin_name_order);
	DDX_Control(pDX, IDC_OPT_EDIT_WINDOW_ORDER, m_edit_window_order);
	DDX_Control(pDX, IDC_OPT_EDIT_TUBE_ORDER, m_edit_tube_order);
	DDX_Control(pDX, IDC_OPT_EDIT_SESSION_ORDER, m_edit_session_order);
	DDX_Control(pDX, IDC_OPT_EDIT_ROOTFLY_NAME, m_rootfly_name);
	DDX_Control(pDX, IDC_OPT_EDIT_NAME_ORDER, m_edit_name_order);
	DDX_Control(pDX, IDC_OPT_EDIT_NAME, m_edit_name);
  DDX_Control(pDX, IDC_OPT_BUTTON_DIR, m_dir_browse);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionsDlg, CDialog)
	//{{AFX_MSG_MAP(COptionsDlg)
	ON_EN_CHANGE(IDC_OPT_EDIT_NAME_ORDER, OnChangeEditNameOrder)
	ON_EN_CHANGE(IDC_OPT_EDIT_SESSION_ORDER, OnChangeEditSessionOrder)
	ON_EN_CHANGE(IDC_OPT_EDIT_TUBE_ORDER, OnChangeEditTubeOrder)
	ON_EN_CHANGE(IDC_OPT_EDIT_WINDOW_ORDER, OnChangeEditWindowOrder)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionsDlg message handlers

BOOL COptionsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
  CString name;

  m_bname_changed = FALSE;
  m_btube_changed = FALSE;
  m_bsession_changed = FALSE;
  m_bwindow_changed = FALSE;
  
	m_dir_browse.SetButtonStyle(m_dir_browse.GetButtonStyle() | BC_CTL_FOLDERSONLY);
  m_dir_browse.SetFolderFlags(BIF_EDITBOX); 
  m_dir_browse.SetPathName(_T("c:\\")); // default path

  m_edit_name.SetWindowText("exp");
	m_spin_name_order.SetRange(1, 4);
  m_spin_tube_order.SetRange(1, 4);
  m_spin_window_order.SetRange(1, 4);
  m_spin_session_order.SetRange(1, 4);
  m_spin_name_order.SetPos(1);
  m_spin_tube_order.SetPos(2);
  m_spin_window_order.SetPos(3);
  m_spin_session_order.SetPos(4);

  m_edit_name.GetWindowText(name);
  m_order[0].Format(name);
  m_order[1].Format("%%2U%%1T");
  m_order[2].Format("%%2W");
  m_order[3].Format("%%2S");
  m_output_order.Format("%s_%s_%s_%s", m_order[0], m_order[1], m_order[2], m_order[3]);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COptionsDlg::OnOK() 
{
	// TODO: Add extra validation here
  UpdateData(TRUE);
	if((CheckOrder()) && (m_rootfly_name.GetModify()))
  {
    // save all current information
    SetOrder();
    m_rootfly_name.GetWindowText(m_rootfly_file_name);
    m_output_dir = m_dir_browse.GetPathName();
    m_output_order.Format("%s_%s_%s_%s", m_order[0], m_order[1], m_order[2], m_order[3]);
    EndDialog(IDOK);
  }
  else
  {
    AfxMessageBox("Incorrect Order; please check file format order or make sure you have a file name specified!");
  }
}

void COptionsDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	PostMessage(WM_CLOSE);
	CDialog::OnCancel();
}

void COptionsDlg::OnChangeEditNameOrder() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
  m_bname_changed = TRUE;
}

void COptionsDlg::OnChangeEditSessionOrder() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	m_bsession_changed = TRUE;
}

void COptionsDlg::OnChangeEditTubeOrder() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	m_btube_changed = TRUE;
}

void COptionsDlg::OnChangeEditWindowOrder() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	m_bwindow_changed = TRUE;
}

BOOL COptionsDlg::CheckOrder()
{
  if((m_spin_name_order.GetPos() == m_spin_tube_order.GetPos())
    ||(m_spin_name_order.GetPos() == m_spin_window_order.GetPos())
    ||(m_spin_name_order.GetPos() == m_spin_session_order.GetPos())
    ||(m_spin_tube_order.GetPos() == m_spin_window_order.GetPos())
    ||(m_spin_tube_order.GetPos() == m_spin_session_order.GetPos())
    ||(m_spin_window_order.GetPos() == m_spin_session_order.GetPos()))
  {
    return false;
  }
  else
    return true;

}

void COptionsDlg::SetOrder()
{
  CString name;
  m_edit_name.GetWindowText(name);
  if(m_bname_changed)
    m_order[m_spin_name_order.GetPos() - 1].Format("%s", name);
  if(m_btube_changed)
    m_order[m_spin_tube_order.GetPos() - 1].Format("%%2U%%1T");
  if(m_bwindow_changed)
    m_order[m_spin_window_order.GetPos() - 1].Format("%%2W");
  if(m_bsession_changed)
    m_order[m_spin_session_order.GetPos() - 1].Format("%%2S");
}

CString COptionsDlg::GetDirectory() const
{
  return m_output_dir;
}

CString COptionsDlg::GetFileFormat() const
{
  return m_output_order;
}

CString COptionsDlg::GetRootflyFileName() const
{
  return m_rootfly_file_name;
}
