/* 
* Rootfly:  A program for analyzing and measuring roots. 
* Copyright (c) 2005 Clemson University.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or (at
* your option) any later version.
* 
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 

// RootflyDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Rootfly.h"
#include "RootflyDlg.h"
#include "ProcessVideo.h"
#include "ToolsOptionDlg1.h"
#include "FolderDlg.h"
#include "mmConversion.h"
#include "CalibrationDialog.h"
#include "CopySession.h"
#include "Session_Array.h"
#include <vector>

#include <string>
#include <direct.h>

using std::string;


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRootflyDlg dialog

CRootflyDlg::CRootflyDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRootflyDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRootflyDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRootflyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRootflyDlg)
	DDX_Control(pDX, IDC_STATIC_PIXELS_PER_MM, m_static_pixels_per_mm);
	DDX_Control(pDX, IDC_BUTTON_EXTEND_END, m_button_extend_end);
	DDX_Control(pDX, IDC_CHECK_SHOW_IDS, m_check_show_ids);
	DDX_Control(pDX, IDC_BUTTON_ALL_DEAD, m_button_all_dead);
	DDX_Control(pDX, IDC_CHECK_SHOW_DEAD, m_check_show_dead);
	DDX_Control(pDX, IDC_COPY_PREVIOUS, m_copy_previous);
	DDX_Control(pDX, IDC_TRAN_PICT_5, m_Transect_Pict_5);
	DDX_Control(pDX, IDC_TRAN_PICT_4, m_Transect_Pict_4);
	DDX_Control(pDX, IDC_TRAN_PICT_3, m_Transect_Pict_3);
	DDX_Control(pDX, IDC_TRAN_PICT_2, m_Transect_Pict_2);
	DDX_Control(pDX, IDC_TRAN_PICT_1, m_Transect_Pict_1);
	DDX_Control(pDX, IDC_SESS_PICT_5, m_Session_Pict_5);
	DDX_Control(pDX, IDC_SESS_PICT_4, m_Session_Pict_4);
	DDX_Control(pDX, IDC_SESS_PICT_3, m_Session_Pict_3);
	DDX_Control(pDX, IDC_SESS_PICT_2, m_Session_Pict_2);
	DDX_Control(pDX, IDC_SESS_PICT_1, m_Session_Pict_1);
	DDX_Control(pDX, IDC_EDIT_LENGTH, m_edit_length);
	DDX_Control(pDX, IDC_EDIT_DIAMETER, m_edit_diameter);
	DDX_Control(pDX, IDC_COMBO_STATE, m_combo_state);
	DDX_Control(pDX, IDC_COMBO_COLOR, m_combo_color);
	DDX_Control(pDX, IDC_EDIT_ID, m_edit_id);
	DDX_Control(pDX, IDC_BUTTON_REGISTER, m_register_control);
	DDX_Control(pDX, IDC_EDIT_WINDOW, m_edit_window);
	DDX_Control(pDX, IDC_EDIT_TUBE, m_edit_tube);
	DDX_Control(pDX, IDC_EDIT_TRANSECT, m_edit_transect);
	DDX_Control(pDX, IDC_EDIT_SESSION, m_edit_session);
	DDX_Control(pDX, IDC_SPIN_WINDOW, m_spin_window);
	DDX_Control(pDX, IDC_SPIN_SESSION, m_spin_session);
	DDX_Control(pDX, IDC_SPIN_TUBE, m_spin_tube);
	DDX_Control(pDX, IDC_SPIN_TRANSECT, m_spin_transect);
	DDX_Control(pDX, IDC_NEW_ROOT, m_new_root_control);
	DDX_Control(pDX, IDC_STATIC_IMAGE, m_static_image);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRootflyDlg, CDialog)
  //{{AFX_MSG_MAP(CRootflyDlg)
  ON_WM_SYSCOMMAND()
  ON_WM_PAINT()
  ON_WM_QUERYDRAGICON()
  ON_COMMAND(ID_Load_Images, OnLoadImages)
  ON_BN_CLICKED(IDC_NEW_ROOT, OnNewRoot)
  ON_WM_LBUTTONDOWN()
  ON_COMMAND(ID_SAVE_AS, OnSaveAs)
  ON_COMMAND(ID_Open, OnOpen)
  ON_COMMAND(ID_EXIT, OnExit)
  ON_COMMAND(ID_CONTEXT_BLACK, OnContextBlack)
  ON_COMMAND(ID_CONTEXT_DARKBROWN, OnContextDarkBrown)
  ON_COMMAND(ID_CONTEXT_LIGHTBROWN, OnContextLightBrown)
  ON_COMMAND(ID_CONTEXT_WHITE, OnContextWhite)
  ON_WM_LBUTTONDBLCLK()
  ON_COMMAND(ID_SAVE, OnSave)
  ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_TUBE, OnDeltaposSpinTube)
  ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_SESSION, OnDeltaposSpinSession)
  ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_TRANSECT, OnDeltaposSpinTransect)
  ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_WINDOW, OnDeltaposSpinWindow)
  ON_COMMAND(ID_NEW, OnNew)
  ON_BN_CLICKED(IDC_BUTTON_REGISTER, OnButtonRegister)
  ON_WM_LBUTTONUP()
  ON_WM_RBUTTONDOWN()
  ON_WM_CLOSE()
  ON_WM_MOUSEMOVE()
  ON_EN_KILLFOCUS(IDC_EDIT_DIAMETER, OnKillfocusEditDiameter)
  ON_EN_KILLFOCUS(IDC_EDIT_TUBE, OnKillfocusEditTube)
  ON_EN_KILLFOCUS(IDC_EDIT_TRANSECT, OnKillfocusEditTransect)
  ON_EN_KILLFOCUS(IDC_EDIT_WINDOW, OnKillfocusEditWindow)
  ON_EN_KILLFOCUS(IDC_EDIT_SESSION, OnKillfocusEditSession)
  ON_CBN_SELCHANGE(IDC_COMBO_COLOR, OnSelchangeComboColor)
  ON_CBN_SELCHANGE(IDC_COMBO_STATE, OnSelchangeComboState)
  ON_BN_CLICKED(IDC_COPY_PREVIOUS, OnCopyPrevious)
  ON_BN_CLICKED(IDC_CHECK_SHOW_DEAD, OnCheckShowDead)
  ON_BN_CLICKED(IDC_BUTTON_ALL_DEAD, OnButtonAllDead)
  ON_BN_CLICKED(IDC_CHECK_SHOW_IDS, OnCheckShowIds)
  ON_COMMAND(ID_EXPORT, OnExport)
  ON_COMMAND(ID_COPY_SESSION, OnCopySession)
  ON_BN_CLICKED(IDC_BUTTON_EXTEND_END, OnButtonExtendEnd)
  ON_COMMAND(ID_MM_CONVERSION, OnMmConversion)
  ON_COMMAND(ID_CHANGE_DIRECTORY, OnChangeDirectory)
  ON_COMMAND(ID_HELP_ABOUTROOTFLY, OnHelpAboutrootfly)
  ON_COMMAND(ID_EDIT_NEWROOT, OnEditNewroot)
  ON_COMMAND(ID_EDIT_DELETEROOT, OnEditDeleteroot)
  ON_COMMAND(ID_EDIT_EXTENDENDPOINT, OnEditExtendendpoint)
  ON_COMMAND(ID_EDIT_REGISTER, OnEditRegister)
  ON_COMMAND(ID_EDIT_COPYFROMPREVIOUS, OnEditCopyfromprevious)
  ON_EN_KILLFOCUS(IDC_EDIT_DIAMETER, OnKillfocusEditDiameter)
  ON_COMMAND(ID_Load_Images, OnLoadImages)
  ON_WM_TIMER()
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRootflyDlg message handlers

BOOL CRootflyDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
  
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
      CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
   GetWindowText(m_base_title);

   m_number_click = 0;
   m_ascii_add = 64;
   m_image_filename = "";
   m_addline = false;
   m_adddiameter = false;
   m_registering = false;
   m_editing_point = false;
   m_resizing_diameter = false;
   m_moving_diameter = false;
   m_extend_end = false;
   m_open = false;
   m_selected_root_id = -1;
   m_have_set_default_image_format = false;
   m_check_show_dead.SetCheck(1);
   m_check_show_ids.SetCheck(1);

   m_curr_tube = -1;
   m_spin_tube.SetRange32(0,0);
   m_spin_tube.SetPos(0);

   m_curr_transect = -1;
   m_spin_transect.SetRange32(0,0);
   m_spin_transect.SetPos(0);
   m_edit_transect.SetWindowText("--");

   m_curr_window = -1;
   m_spin_window.SetRange32(0,0);
   m_spin_window.SetPos(0);

   m_curr_session = -1;
   m_spin_session.SetRange32(0,0);
   m_spin_session.SetPos(0);

   m_data.m_mm_conversion = 1;
   m_data.SetModify(false);
   UpdatePixelsPerMmDisplay();
   UpdateTitleBar();

   // load all the cursors that will be used
   m_cur_openhand = AfxGetApp()->LoadCursor(IDC_CUR_OPENHAND);
   m_cur_closedhand = AfxGetApp()->LoadCursor(IDC_CUR_CLOSEDHAND);
   m_cur_uparrow = AfxGetApp()->LoadStandardCursor(IDC_UPARROW);
   m_cur_sizeall = AfxGetApp()->LoadStandardCursor(IDC_SIZEALL);
   m_cur_sizens = AfxGetApp()->LoadStandardCursor(IDC_SIZENS);

   // disable edit boxes, grayed out
   m_edit_tube.EnableWindow(false);
   m_edit_transect.EnableWindow(false);
   m_edit_window.EnableWindow(false);
   m_edit_session.EnableWindow(false);

   m_edit_tube.SetReadOnly();
   m_edit_transect.SetReadOnly();
   m_edit_window.SetReadOnly();
   m_edit_session.SetReadOnly();

   // disable combo boxes
   m_combo_color.EnableWindow(false);
   m_combo_state.EnableWindow(false);

   // disable buttons
   m_button_all_dead.EnableWindow(false);
   m_new_root_control.EnableWindow(false);
   m_register_control.EnableWindow(false);
   m_copy_previous.EnableWindow(false);
   m_button_extend_end.EnableWindow(false);

   CRect rect;
   m_static_image.GetWindowRect(&rect);
   ScreenToClient(&rect);
   m_image_topleft.x = rect.left;
   m_image_topleft.y = rect.top;
   m_image_scale = 640.0 / (double)(rect.right - rect.left);

   EnableDisable(false);
   EnableDisableRootControls(false);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRootflyDlg::EnableDisable(bool file_loaded)
{
  unsigned flag = file_loaded ? MF_ENABLED : MF_GRAYED;
  CMenu *menu = GetMenu();
  menu->EnableMenuItem(ID_SAVE, flag);
  menu->EnableMenuItem(ID_SAVE_AS, flag);
  menu->EnableMenuItem(ID_EXPORT, flag);
  menu->EnableMenuItem(ID_EDIT_NEWROOT, flag);
  menu->EnableMenuItem(ID_EDIT_REGISTER, flag);
  menu->EnableMenuItem(ID_EDIT_COPYFROMPREVIOUS, flag);
  menu->EnableMenuItem(ID_COPY_SESSION, flag);
  menu->EnableMenuItem(ID_MM_CONVERSION, flag);
}

void CRootflyDlg::EnableDisableRootControls(bool file_loaded)
{
  unsigned flag = file_loaded ? MF_ENABLED : MF_GRAYED;
  CMenu *menu = GetMenu();
  menu->EnableMenuItem(ID_EDIT_EXTENDENDPOINT, flag);
  menu->EnableMenuItem(ID_EDIT_DELETEROOT, flag);
}

void CRootflyDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
	   CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRootflyDlg::OnPaint() 
{
   if (IsIconic())
   {
      CPaintDC dc(this); // device context for painting
    
      SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

      // Center icon in client rectangle
      int cxIcon = GetSystemMetrics(SM_CXICON);
      int cyIcon = GetSystemMetrics(SM_CYICON);
      CRect rect;
      GetClientRect(&rect);
      int x = (rect.Width() - cxIcon + 1) / 2;
      int y = (rect.Height() - cyIcon + 1) / 2;

      // Draw the icon
      dc.DrawIcon(x, y, m_hIcon);
   }
   else  
   {  
      CDialog::OnPaint();
      ReDraw();
      UpdateThumbnails();
   }
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRootflyDlg::OnQueryDragIcon()
{
   return (HCURSOR) m_hIcon;
}

void CRootflyDlg::UpdatePixelsPerMmDisplay()
{
  CString str;
  str.Format("%5.1f pixels per millimeter", m_data.m_mm_conversion);
  m_static_pixels_per_mm.SetWindowText(str);
}

void CRootflyDlg::OnLoadImages() 
{
   CString filename;
   blepo::ImgBgr myImage;
    
   blepo::Load(filename, &myImage);
   Invalidate();
}

void CRootflyDlg::OnExit() 
{
  PostMessage(WM_CLOSE);	
}

void CRootflyDlg::OnOpen() 
{
   int return_value;

// Save File if Modified
   if(m_data.GetModify())
   {
      return_value = AfxMessageBox("Project data has changed. Save changes?",MB_YESNOCANCEL);

      if(return_value == IDYES)
      {
         OnSave();//call the save function if things have changed 
      }
      else if(return_value == IDCANCEL)
      {
         return;
      }
   } // Save Modified File


   int ntube, ntrans, nwin, nsess;
   CString temp_filename;

   CFileDialog fldg(TRUE,NULL,NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,"Rootfly File(*.rfy)|*.rfy|All Files(*.*)|*.*||",this);

   if(fldg.DoModal() == IDOK)
   {
      m_filename = fldg.GetPathName();

      if(m_data.Load(m_filename))
      {
         m_file_directory = ExtractDirectory(m_filename);
         m_data.m_root.GetDimensions(&ntube, &ntrans, &nwin, &nsess);

         EnableDisable(true);
         EnableDisableRootControls(false);

		 m_open = true;
// JLF - 05/19/06
		 m_file_directory = m_data.m_image_directory;

         bool dir_modified = ScanDirectory();
         m_data.SetModify(dir_modified);
         UpdatePixelsPerMmDisplay();
         UpdateTitleBar();
      } //end if
      else
      {
         AfxMessageBox("Selected file could not be opened.");
      } //end else
   } //end if
} //end OnOpen

void CRootflyDlg::OnContextBlack()
{

   CString temp;
   RootInstance *temp_root;
   bool root_status;

   if ((m_current_rootlist != NULL)&&(m_selected_root_id != -1))
   {
	   temp_root = m_current_rootlist->at(m_selected_root_id).GetRootInstance(m_curr_session,&root_status);

       temp_root->color = COLOR_BLACK;

      m_data.SetModify();
      UpdateTitleBar();
      ReDraw();
   } //end if

}

void CRootflyDlg::OnContextDarkBrown()
{

   CString temp;
   RootInstance *temp_root;
   bool root_status;

   if ((m_current_rootlist != NULL)&&(m_selected_root_id != -1))
   {
	   temp_root = m_current_rootlist->at(m_selected_root_id).GetRootInstance(m_curr_session,&root_status);

       temp_root->color = COLOR_DARKBROWN;

      m_data.SetModify();
      UpdateTitleBar();
      ReDraw();
   } //end if

}

void CRootflyDlg::OnContextLightBrown()
{

   CString temp;
   RootInstance *temp_root;
   bool root_status;

   if ((m_current_rootlist != NULL)&&(m_selected_root_id != -1))
   {
      temp_root = m_current_rootlist->at(m_selected_root_id).GetRootInstance(m_curr_session,&root_status);

      temp_root->color = COLOR_LIGHTBROWN;

      m_data.SetModify();
      UpdateTitleBar();
      ReDraw();
   } //end if

}

void CRootflyDlg::OnContextWhite()
{

   CString temp;
   RootInstance *temp_root;
   bool root_status;

   if ((m_current_rootlist != NULL)&&(m_selected_root_id != -1))
   {
      temp_root = m_current_rootlist->at(m_selected_root_id).GetRootInstance(m_curr_session,&root_status);

      temp_root->color = COLOR_WHITE;

      m_data.SetModify();
      UpdateTitleBar();
      ReDraw();
   } //end if

}

void CRootflyDlg::OnNewRoot() 
{
   if(m_open)
   {
      m_selected_root_id = -1;
      m_addline = true;
      m_adddiameter = false;
      m_registering = false;
      m_extend_end = false;
      m_number_click = 0;
      m_temp_root.color = COLOR_DARKBROWN;
      m_temp_root.diameter = 0.0;
      m_temp_root.points.clear();
      ReDraw();
   } //end if
} //end OnNewRoot


// Newroot: From Edit Menu
void CRootflyDlg::OnEditNewroot(){

   if(m_open)
   {
      m_selected_root_id = -1;
      m_addline = true;
      m_adddiameter = false;
      m_registering = false;
      m_extend_end = false;
      m_number_click = 0;
      m_temp_root.color = COLOR_DARKBROWN;
      m_temp_root.diameter = 0.0;
      m_temp_root.points.clear();
      ReDraw();
   } //end if

} // OnEditNewroot

void CRootflyDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{ 
   SetFocus();

   CRect rect;
   CRgn rgn;
   m_static_image.GetWindowRect(&rect);
   ScreenToClient(&rect);
   rgn.CreateRectRgnIndirect(&rect);

   if(rgn.PtInRegion(point))
   {

      /* 05/23/06 - Only Enable Root Actions when Root Selected JLF */
      EnableDisableRootControls(false);

      if(m_addline)
      {
         CPoint oldpoint = point;
         ReAdjustPoint(point);

         m_number_click++;
         if(m_number_click==1)
         {
            m_temp_root.color = COLOR_WHITE;
            m_temp_root.diameter = 0.0;
            m_temp_root.points.push_back(point);
         } //end if
         else if(m_number_click > 1)
         {
            m_temp_root.points.push_back(point);
            ReDraw(0,oldpoint);
         } //end else
      }	//end if
      else if (m_adddiameter)
      {
         ReAdjustPoint(point);

         m_number_click++;
         
         if (m_number_click == 2)
         {
            int x_value = m_temp_root.diameter_center.x - point.x;
            int y_value = m_temp_root.diameter_center.y - point.y;
            m_temp_root.diameter = 2*sqrt((double)((x_value * x_value) + (y_value * y_value)));

            m_adddiameter = false;
            m_number_click = 0;

            RootOverTime temp_root_ot;
            RootInstance *temp_root_instance;

            temp_root_instance = temp_root_ot.CreateRootInstance(m_curr_session);
            *(temp_root_instance) = m_temp_root;

            m_current_rootlist->push_back(temp_root_ot);
            m_data.SetModify();
            UpdateTitleBar();

            ReDraw();
         } //end else-if
      } //end else-if
      else if(m_registering)
      {
         m_number_click++;
         if (m_number_click == 1)
         {
            point.x = (point.x - m_image_topleft.x) * m_image_scale;
            point.y = (point.y - m_image_topleft.y) * m_image_scale;
            m_register_point = point;
         } //end if
      }
      else if(m_extend_end && (m_selected_root_id >= 0))
      {
        bool status;
        int first_or_last;

        RootInstance *temp_rootinstance;
        temp_rootinstance = m_current_rootlist->at(m_selected_root_id).GetRootInstance(m_curr_session,&status);
  
        ReAdjustPoint(point);
        first_or_last=DetermineClosestEnd(point,temp_rootinstance);

        using namespace std;
        vector<CPoint>::iterator theIterator= temp_rootinstance->points.begin();

        if (first_or_last==0)
          temp_rootinstance->points.insert(theIterator, 1 ,point);
        else
          temp_rootinstance->points.push_back(point);

/* 05/25/06 - JLF - Fix for Endpoint Extension Bug */
//        OnRButtonDown(nFlags,point);
//        m_extend_end = false;
        m_extend_end = true;
        ReDraw(0,point);
      }
      else if(m_selected_root_id >= 0)
      {

         if(IsOnPoint(point) >= 0)
         {
            m_selected_point_id = IsOnPoint(point);
            m_editing_point = true;
            m_data.SetModify();
            UpdateTitleBar();
            SetCursor(m_cur_sizeall);
         }
         else if(IsOnDiameterPoint(point))
         {
            m_resizing_diameter = true;
            m_data.SetModify();
            UpdateTitleBar();
            SetCursor(m_cur_sizens);
         }
         else if(IsOnDiameter(point))
         {
            m_moving_diameter = true;
            {
              bool alive;
              RootInstance *temp;
              temp = m_current_rootlist->at(m_selected_root_id).GetRootInstance(m_curr_session, &alive);
              CPoint pt = point;
              ReAdjustPoint(pt); // convert to image coordinates
              m_moving_diameter_offset = pt - temp->diameter_center;
            }
            m_data.SetModify();
            UpdateTitleBar();
            SetCursor(m_cur_closedhand);
         }
         else
         {
            m_selected_root_id = IsOnRoot(point);
            ReDraw();
         }
      }
      else
      {
        EnableDisableRootControls(true);
        m_selected_root_id = IsOnRoot(point);
        ReDraw();
      }

   } //end if
   else if(m_open)
   {
      EnableDisableRootControls(false);

      CRect w1,w2,w4,w5,s1,s2,s4,s5;
      int tu,tr,wn,sn;
      CString temp_str;
      m_data.m_root.GetDimensions(&tu, &tr, &wn, &sn);

      m_Transect_Pict_1.GetWindowRect(&w1);
      ScreenToClient(w1);
      m_Transect_Pict_2.GetWindowRect(&w2);
      ScreenToClient(w2);
      m_Transect_Pict_4.GetWindowRect(&w4);
      ScreenToClient(w4);
      m_Transect_Pict_5.GetWindowRect(&w5);
      ScreenToClient(w5);
      m_Session_Pict_1.GetWindowRect(&s1);
      ScreenToClient(s1);
      m_Session_Pict_2.GetWindowRect(&s2);
      ScreenToClient(s2);
      m_Session_Pict_4.GetWindowRect(&s4);
      ScreenToClient(s4);
      m_Session_Pict_5.GetWindowRect(&s5);
      ScreenToClient(s5);

      if(w1.PtInRect(point)) //Go back 2 windows
      {
         m_edit_window.GetWindowText(temp_str);
         if(atoi(temp_str) >= 3)
         {
            if(ChangeLocation(m_curr_tube, m_curr_transect, m_curr_window - 2, m_curr_session))
            {
               temp_str.Format("%d", m_curr_window+1);
               m_edit_window.SetWindowText(temp_str);
            }
         }
      }
      else if(w2.PtInRect(point))
      {
         m_edit_window.GetWindowText(temp_str);
         if(atoi(temp_str) >= 2)
         {
            if(ChangeLocation(m_curr_tube, m_curr_transect, m_curr_window - 1, m_curr_session))
            {
               temp_str.Format("%d", m_curr_window+1);
               m_edit_window.SetWindowText(temp_str);
            }
         }
      }
      else if(w4.PtInRect(point))
      {
         m_edit_window.GetWindowText(temp_str);
         if(atoi(temp_str) < wn)
         {
            if(ChangeLocation(m_curr_tube, m_curr_transect, m_curr_window + 1 , m_curr_session))
            {
               temp_str.Format("%d", m_curr_window+1);
               m_edit_window.SetWindowText(temp_str);
            }
         }
      }
      else if(w5.PtInRect(point))
      {
         m_edit_window.GetWindowText(temp_str);
         if(atoi(temp_str) < wn-1)
         {
            if(ChangeLocation(m_curr_tube, m_curr_transect, m_curr_window + 2, m_curr_session))
            {
               temp_str.Format("%d", m_curr_window+1);
               m_edit_window.SetWindowText(temp_str);
            }
         }
      }
      else if(s1.PtInRect(point))
      {
         m_edit_session.GetWindowText(temp_str);
         if(atoi(temp_str) >= 3)
         {
            if(ChangeLocation(m_curr_tube, m_curr_transect, m_curr_window, m_curr_session - 2))
            {
               temp_str.Format("%d", m_curr_session+1);
               m_edit_session.SetWindowText(temp_str);
            }
         }
      }
      else if(s2.PtInRect(point))
      {
         m_edit_session.GetWindowText(temp_str);
         if(atoi(temp_str) >= 2)
         {
            if(ChangeLocation(m_curr_tube, m_curr_transect, m_curr_window, m_curr_session - 1))
            {
               temp_str.Format("%d", m_curr_session+1);
               m_edit_session.SetWindowText(temp_str);
            }
         }
      }
      else if(s4.PtInRect(point))
      {
         m_edit_session.GetWindowText(temp_str);
         if(atoi(temp_str) < sn)
         {
            if(ChangeLocation(m_curr_tube, m_curr_transect, m_curr_window, m_curr_session + 1))
            {
               temp_str.Format("%d", m_curr_session+1);
               m_edit_session.SetWindowText(temp_str);
            }
         }
      }
      else if(s5.PtInRect(point))
      {
         m_edit_session.GetWindowText(temp_str);
         if(atoi(temp_str) < sn-1)
         {
            if(ChangeLocation(m_curr_tube, m_curr_transect, m_curr_window, m_curr_session + 2))
            {
               temp_str.Format("%d", m_curr_session+1);
               m_edit_session.SetWindowText(temp_str);
            }
         }
      }
   }

	CDialog::OnLButtonDown(nFlags, point);

} //end OnLButtonDown

void CRootflyDlg::OnSaveAs() 
{
	CFileDialog fldg(FALSE,"rfy",NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,"Rootfly Files(*.rfy)|*.rfy|All Files(*.*)|*.*||",this);

	if(m_open)
	{
		if(fldg.DoModal() == IDOK)
		{

/* Date: 05/19/06
 *
 * Changes to Make:
 *    Rootfly File contains directory pictures are stored in
 */
// m_filename is the directory that the user has selected to store the file,
//    concatenated with the filename

         m_filename = fldg.GetPathName();
         m_data.Save(m_filename);
         m_data.SetModify(false);
         UpdateTitleBar();
		}
	}
	else
		AfxMessageBox("No file open.");
}

void CRootflyDlg::OnLButtonDblClk(UINT nFlags, CPoint point)
{
   CRect rect;
   CRgn rgn;
   m_static_image.GetWindowRect(&rect);
   ScreenToClient(&rect);
   rgn.CreateRectRgnIndirect(&rect);
   if(rgn.PtInRegion(point))
   {
      if(m_addline && m_number_click > 1)
      {
         m_addline = false;
         m_adddiameter = true;
         m_number_click = 1;
         CPoint temp_point = point;
         ReAdjustPoint(temp_point);
         m_temp_root.diameter_center = temp_point;
         ReDraw(0,point);
      } //end if

/* 05/24/06 - JLF - Double Click ends Extend Endpoint */
      if(m_extend_end)
      {
        m_extend_end = false;
      }
   } //end if
	CDialog::OnLButtonDblClk(nFlags, point);
}

void CRootflyDlg::OnSave() 
{
   if( m_filename != "" && m_filename != "New.rfy")
   {
	   m_data.Save(m_filename);
      m_data.SetModify(false);
      UpdateTitleBar();
   }
	else
		OnSaveAs();
}

void CRootflyDlg::OnDeltaposSpinTube(NMHDR* pNMHDR, LRESULT* pResult) 
{
  NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;

  /* 05/24/06 - JLF : If Tube is changed, session and window should go back to 1 */
  /* NOTE: curr_window/session zero based */
  m_spin_window.SetPos(1);
  m_curr_window = 0;
  m_spin_session.SetPos(1);
  m_curr_session = 0;
  
  if(!ChangeLocation(pNMUpDown->iPos + pNMUpDown->iDelta - 1, m_curr_transect, m_curr_window, m_curr_session))
  {
    m_spin_tube.SetPos(m_curr_tube + 1);



    *pResult = 1;
  }
  else
  {
    *pResult = 0;
  }

}

void CRootflyDlg::OnDeltaposSpinSession(NMHDR* pNMHDR, LRESULT* pResult) 
{
  NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
  if(!ChangeLocation(m_curr_tube, m_curr_transect, m_curr_window, pNMUpDown->iPos + pNMUpDown->iDelta - 1))
  {
    m_spin_session.SetPos(m_curr_session + 1);
    *pResult = 1;
  }
  else
  {
    *pResult = 0;
  }

}

void CRootflyDlg::OnDeltaposSpinTransect(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
   //CString temp;
	//*pResult = UpdateImage(2,pNMUpDown);

   if(!ChangeLocation(m_curr_tube, pNMUpDown->iPos + pNMUpDown->iDelta - 1, m_curr_window, m_curr_session))
   {
      m_spin_transect.SetPos(pNMUpDown->iPos);
	   if( m_curr_transect == 0 )
	   {
		   m_edit_transect.SetWindowText("A");
	   }
	   else if( m_curr_transect == 1 )
	   {
		   m_edit_transect.SetWindowText("B");
	   }
	   else if( m_curr_transect == 2 )
	   {
		   m_edit_transect.SetWindowText("C");
	   }
      *pResult = 1;
   }
   else
   {
      *pResult = 1;
      m_curr_transect = pNMUpDown->iPos + pNMUpDown->iDelta - 1;
      m_spin_transect.SetPos(pNMUpDown->iPos + pNMUpDown->iDelta);
	   if( m_curr_transect == 0 )
	   {
		   m_edit_transect.SetWindowText("A");
	   }
	   else if( m_curr_transect == 1 )
	   {
		   m_edit_transect.SetWindowText("B");
	   }
	   else if( m_curr_transect == 2 )
	   {
		   m_edit_transect.SetWindowText("C");
	   }
   }
}

void CRootflyDlg::OnDeltaposSpinWindow(NMHDR* pNMHDR, LRESULT* pResult) 
{
   NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;

  /* 05/24/06 - JLF : If Window is changed, session should go back to 1 */
  /* NOTE: curr_window/session zero based */
  m_spin_session.SetPos(1);
  m_curr_session = 0;

   if(!ChangeLocation(m_curr_tube, m_curr_transect, pNMUpDown->iPos + pNMUpDown->iDelta - 1, m_curr_session))
   {
      m_spin_window.SetPos(m_curr_window + 1);
      *pResult = 1;
   }
   else
   {
      *pResult = 0;
   }
}

// ------------------------------------------------------------------------------------------------

void CRootflyDlg::OnNew() 
{
   //check to see if your done with your current business
   int return_value;



// Check to see if current File Needs to be Saved
   if(m_data.GetModify())
   {
      return_value = AfxMessageBox("Project data has changed. Save changes?",MB_YESNOCANCEL);

      if(return_value == IDYES)
      {
         OnSave();//call the save function if things have changed 
      }
      else if(return_value == IDCANCEL)
      {
         return;
      }
   } // Save File


   m_selected_root_id = -1;
 //  OnMmConversion();
   
   UINT	uFlags	  = BIF_RETURNONLYFSDIRS | BIF_USENEWUI;
   CFolderDialog dlg(_T("Choose Folder where Images are Located" ), m_file_directory, this, uFlags);
   if(dlg.DoModal() == IDOK)
   {
      //st the directory to be used
      m_file_directory = dlg.GetFolderPath();
      m_file_directory = m_file_directory + "\\";
      m_data.m_image_directory = m_file_directory;

      //set the version to be saved out
      m_data.m_version = "Rootfly_11";

      //set the default image format the first time new is invoked
      //otherwise, keep it at what it was previously set at (via tools::options)
      if( m_have_set_default_image_format == false )
      {
/* CHANGED FOR BARTZ FILE - JLF - 05/12/06 */
         m_data.m_image_format = "Bartz_format";
//         m_data.m_image_format = "image_%2U%1T_%2W_%2S";
         m_have_set_default_image_format = true;
      }
      EnableDisable(true);
      EnableDisableRootControls(false);
      
      m_filename = "New.rfy";
      m_open = true;
      m_data.m_root.Clear();
      ScanDirectory();
      m_data.SetModify(false);
      UpdateTitleBar();
   }
   else
      return;
}

// ----------------------------------------------------------------------------------------------------------

// CheckIfCorrectString - Determines if file name (temp_string) is the file
//    we want, based on tube window and session -- JLF
//int CheckIfCorrectString(CString temp_string, int tube, int window, int session, Session_Array* m_session_array){
//
//  int fileTube;
//  int fileWindow;
//  int fileDate;
//
//  CString tmp;
//  int i; 
//
///* Get Variables from this File */
//  // get tube
//  i = temp_string.Find("_T", 0);
//  tmp = temp_string.Mid(i+2, 3);
//  fileTube = atoi(tmp);
//
//  // get window
//  i = temp_string.Find("_L", i);
//  tmp = temp_string.Mid(i+2, 3);
//  fileWindow = atoi(tmp);
//
//  // get date
//  tmp = temp_string.Mid(i+6, 4);
//  int year = atoi(tmp);
//  tmp = temp_string.Mid(i+11, 2);
//  int month = atoi(tmp);
//  tmp = temp_string.Mid(i+14, 2);
//  int day = atoi(tmp);
//  fileDate = year * 10000 + month * 100 + day;
//
//  Date date = m_session_array->GetDate(session);
//
///* Check file's variables against desired variables */  
//  if(fileTube != tube)
//	  return 0;
//  if(fileWindow != window)
//	  return 0;
//  if(fileDate != date)
//	  return 0;
//
//  return 1;
//
//}

// ----------------------------------------------------------------------------------------------------------

// New ImageName() - JLF
// Changes:
//     - Takes directory as argument
//     - Calls FileFind to get all files that match tube, window session(date)
//	    (Either zero or one)
//     - Returns filename or emptyString
CString CRootflyDlg::ImageName(CString directory, int tube, int window, int session)
{
  int NumberOfTries = 0;
  CFileFind finder;
  Date date = m_session_array.GetDate(session);
  CString fname;
  CString temp_string;


  while(NumberOfTries < 3){
    fname.Format("*_T%03d_L%03d_%04d.%02d.%02d_*.jpg", tube, window, date.year, date.month, date.day);

    //scan the directory for images
    int bResult = finder.FindFile(m_file_directory + fname);

    if (bResult != 0)
    {
      NumberOfTries = 9;  // We're done looking
      bResult = finder.FindNextFile();
      if (bResult == 0)
      {
        return finder.GetFilePath();  // return the first one we find; hopefully there is only one
      } 
      else
      {
        assert(0);  // found more than one file, or an error occurred
      }
    }
    else{
      NumberOfTries++;
      date++;
    }
  }

  return "";

//  int date = m_session_array->GetDate(session);
//  int year = date / 10000;
//  int month = (date-year*10000) / 100;
//  int day = (date-year*10000-month*100);
//
//
//
//
//// directory - current directory
//
//  CFileFind finder;
//  CString temp_string;
//  std::vector<CString> fileNames;
//
//  int bResult = finder.FindFile(m_file_directory + ".jpg");
//  int result  = 0;
//
////scan the directory for images
//  while(bResult != 0){
//    bResult = finder.FindNextFile();
//    temp_string = finder.GetFileTitle();
//
//	result = CheckIfCorrectString(temp_string, tube, window, session, &m_session_array);
//
//	if(result == 1)
//       fileNames.push_back(temp_string);
//  }
//
//  finder.Close();
//
//  if(fileNames.size() == 1)
//	  return fileNames.at(0);

  return "";

} // ImageName()

// ----------------------------------------------------------------------------------------------------------

//CString CRootflyDlg::ImageName(CString format, int tube, char transect, int window, int session)
//{
//   CString name, temp_value;
//   
//   name = m_data.m_image_format;
//   temp_value.Format("%02d", tube);
//   name.Replace("%2U", temp_value);
//   temp_value.Format("%c", transect);
//   name.Replace("%1T", temp_value);
//   temp_value.Format("%02d", window);
//   name.Replace("%2W", temp_value);
//   temp_value.Format("%02d", session);
//   name.Replace("%2S", temp_value);
//   //name += ".bmp";
//   name += ".jpg";
//
////   name += ".jpg";
//
//  return name;
//}

// ----------------------------------------------------------------------------------------------------------

bool CRootflyDlg::IsBitmap(CString fname)
{
   const char char_bmp[] = "BM";
   const char char_jpg[5] = {'\xFF','\xD8','\xFF','\xE0','\0'};
   char data[5];
   bool is_bitmap = true;

   {  // Determine file type
      FILE* fp;
      long result;

      if (fname.Compare("") == 0)
      {
         is_bitmap = false;
      } //end if
      else
      {
         fp = fopen(fname,"rb");
      } //end else
      if (fp==NULL)  
      {
         is_bitmap = false;  // BLEPO_ERROR(StringEx("Unable to open file '%s'", fname));
      }
      if (is_bitmap) 
      {
         result=fread(data,1,4,fp); //read magic characters
         if (result==0)  
         {
            is_bitmap = false;  // BLEPO_ERROR("Error reading file");
         }
         data[4]='\0';
         fclose(fp);
      }
   }
   if(strnicmp(data,char_bmp,strlen(char_bmp))!=0 && strnicmp(data,char_jpg,strlen(char_jpg))!=0)
   {
      is_bitmap = false;  // BLEPO_ERROR("Filetype not supported");
   }
   return is_bitmap;
} //end IsBitmap

CString CRootflyDlg::ExtractDirectory(CString filename)
{
   for (int i=filename.GetLength()-1; i>=0; i--)
   {
      if (filename.GetAt(i) == '\\')
      {
         filename.Delete(i,filename.GetLength()-i);
         filename = filename+'\\';
         break;
      } //end if
   } //end for
   return filename;
} //end ExtractDirectory

CString CRootflyDlg::ExtractFile(CString filename)
{
   for (int i=filename.GetLength()-1; i>=0; i--)
   {
      if (filename.GetAt(i) == '\\')
      {
         filename.Delete(0,i+1);
         break;
      } //end if
   } //end for
   return filename;
} //end ExtractFile

void CRootflyDlg::OnButtonRegister() 
{
   m_registering = true;
   m_addline = false;
   m_adddiameter = false;
   m_extend_end = false;
   m_number_click = 0;
   m_selected_root_id = -1;
   m_highlighted_root_id = -1;
   ReDraw();
} //end OnButtonRegister

void CRootflyDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
   CPoint delta_point;
   point.x = (point.x - m_image_topleft.x) * m_image_scale;
   point.y = (point.y - m_image_topleft.y) * m_image_scale;

   if (m_registering && (m_number_click > 0))
   {
      delta_point = point - m_register_point;

      CPoint temp_point;
      temp_point = m_current_rootlist->offset_list.at(m_curr_session);
      m_current_rootlist->offset_list.at(m_curr_session) = temp_point + delta_point;
      m_registering = false;
      m_data.SetModify();
      UpdateTitleBar();
      ReDraw();
      ClipCursor(NULL);
   } //end if

   if(m_editing_point)
   {
      m_editing_point = false;
      ClipCursor(NULL);
   }

   if(m_moving_diameter)
  {
      m_moving_diameter = false;
      ClipCursor(NULL);
   }

   if(m_resizing_diameter)
   {
      m_resizing_diameter = false;
      ClipCursor(NULL);
   }
	CDialog::OnLButtonUp(nFlags, point);
}

void CRootflyDlg::OnRButtonDown(UINT nFlags, CPoint point) 
{
  
  /* 05-30-06 - JLF; Removed line to prevent diameter circle from moving */
  //  OnLButtonDown(nFlags, point);
  
  // select root on which user clicked
  m_selected_root_id = IsOnRoot(point);
  ReDraw();
  
  
  if((IsBitmap(m_image_filename)) && (!m_addline) && (!m_adddiameter) && (!m_registering) && (!m_editing_point) && (!m_moving_diameter) && (!m_resizing_diameter) && (!m_extend_end))
  {
    int temp = m_highlighted_root_id;
    m_highlighted_root_id = IsOnRoot(point);
    
    if(m_highlighted_root_id >= 0)
    {
      
      // show context menu for changing root color
      CMenu menu;
      menu.LoadMenu(IDR_MENU_CONTEXT);
      CMenu* popup = menu.GetSubMenu(0);
      assert(popup != NULL);
      CPoint pt = point;
      ClientToScreen(&pt);
      popup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, this);
      
    }
    
    return;
  } //end if
  
  /* 05/24/06 - JLF - RButtonDown Does not end ExtendEndpoint now */
  //   m_extend_end = false;
  
  
  ReDraw(0,point);
  
}

void CRootflyDlg::OnClose() 
{
   //check to see if any modifications have been made to the file
   int return_value;

   if(m_data.GetModify())
   {
      return_value = AfxMessageBox("Project data has changed. Save changes?",MB_YESNOCANCEL);
      if(return_value == IDNO)
      {
         CDialog::OnClose();
      }
      else if(return_value == IDYES)
      {
         OnSave();//call the save function if things have changed
         CDialog::OnClose();
      }
   }
  
   if(return_value != IDCANCEL)
      CDialog::OnClose();
}

//void CRootflyDlg::OnToolsProcessVideo() 
//{
//   if(m_open)
//   {
//      CProcessVideo pvdialog(m_file_directory, m_data.m_image_format);
//      pvdialog.DoModal();
//      ScanDirectory();
//   } 
//   else 
//   {
//      AfxMessageBox("Use File->New to set the current working directory \n\n Or open a rootfly (.rfy) file");
//   }
//}

//void CRootflyDlg::OnToolsOptions() 
//{
//   CToolsOptionDlg dlg(m_data.m_image_format);
//   if( dlg.DoModal() == IDOK)
//   {
//      m_data.m_image_format = dlg.GetFileFormat();
//      ScanDirectory();
//   }
//}

// sets the modified status and updates the dialog title
void CRootflyDlg::UpdateTitleBar()
{
   CString window_text,temp;

   //display appropriate status bar info
   window_text = m_base_title;
   if (m_filename.Compare("") != 0)
   {
      temp = ExtractFile(m_filename);
      window_text = window_text + " - [" + temp;
   } //end if

   if (m_data.GetModify())
   {
      window_text += " *";
   } //end if

   if (m_filename.Compare("") != 0)
   {
      window_text = window_text + "]";
   } //end if

   SetWindowText(window_text);
}

void CRootflyDlg::OnMouseMove(UINT nFlags, CPoint point)
{
   if((IsBitmap(m_image_filename)) && (!m_addline) && (!m_adddiameter) && (!m_registering) && (!m_editing_point) && (!m_moving_diameter) && (!m_resizing_diameter) && (!m_extend_end))
   {
      int temp = m_highlighted_root_id;
      m_highlighted_root_id = IsOnRoot(point);
      if(m_highlighted_root_id >= 0)
      {
/* 05/25/06 - JLF; No Uparrow anymore */
//         if(m_selected_root_id != m_highlighted_root_id)
//         {
//            SetCursor(m_cur_uparrow);  
//         }
         if(IsOnPoint(point) >= 0)
         {
            SetCursor(m_cur_sizeall);     
         }
         else if(IsOnDiameterPoint(point))
         {
            SetCursor(m_cur_sizens);
         }
         else if(IsOnDiameter(point))
         {
            SetCursor(m_cur_openhand);
         }
      }
      if(m_highlighted_root_id != temp)
      {
         ReDraw();
      } //end if
      return;
   } //end if

   if(m_addline || m_adddiameter)
   {
     ReDraw(0,point);
   }

   if(m_extend_end && (m_selected_root_id >= 0))
   {
      ReDraw(0,point);
   }

   if(m_registering && (m_number_click == 1))
   {
      CRect image_rect;
      m_static_image.GetWindowRect(&image_rect); 
      ClipCursor(&image_rect);
      SetCursor(m_cur_closedhand);

      point.x = (point.x - m_image_topleft.x) * m_image_scale;
      point.y = (point.y - m_image_topleft.y) * m_image_scale;
      m_temp_offset = point - m_register_point;
      ReDraw(1);
   }
   else if(m_registering)
   {
      SetCursor(m_cur_openhand);
   }

   if(m_editing_point)
   {
      CRect image_rect;
      m_static_image.GetWindowRect(&image_rect);
      ClipCursor(&image_rect);
      SetCursor(m_cur_sizeall);

      ReAdjustPoint(point);

      bool alive;
      RootInstance *temp;
      temp = m_current_rootlist->at(m_selected_root_id).GetRootInstance(m_curr_session, &alive);
      temp->points.at(m_selected_point_id) = point;
      ReDraw();
   }

   if(m_moving_diameter)
   {
      CRect image_rect;
      m_static_image.GetWindowRect(&image_rect);
      ClipCursor(&image_rect);

      SetCursor(m_cur_closedhand);

      bool alive;
      RootInstance *temp;
      temp = m_current_rootlist->at(m_selected_root_id).GetRootInstance(m_curr_session, &alive);
      ReAdjustPoint(point);  // convert to image coordinates
      point.Offset(- m_moving_diameter_offset);  // add mouse offset
      temp->diameter_center = point;
      ReDraw();
   }

   if(m_resizing_diameter)
   {
      //double y_center, y_edge, y_offset;
      CRect image_rect;
      m_static_image.GetWindowRect(&image_rect);
      ClipCursor(&image_rect);

      SetCursor(m_cur_sizens);

      CPoint d_center;
      bool alive;
      RootInstance *temp;
      temp = m_current_rootlist->at(m_selected_root_id).GetRootInstance(m_curr_session, &alive);

      ReAdjustPoint(point);
      d_center = temp->diameter_center;
      temp->diameter = sqrt((point.x - d_center.x) * (point.x - d_center.x) + (point.y - d_center.y) * (point.y - d_center.y)) * 2;
      ReDraw();
   }

	CDialog::OnMouseMove(nFlags, point);
}

// returns 0 based root id if a point is near the root, otherwise -1
int CRootflyDlg::IsOnRoot(CPoint point)
{
   if(IsBitmap(m_image_filename))
   {
      //RootList *temp_rootlist = m_data.m_root.GetRootList(m_curr_tube, m_curr_transect, m_curr_window);
      RootInstance *temp_rootinstance;
      bool alive;

      for(int root = 0; root < m_current_rootlist->size(); root++)
      {
         temp_rootinstance = m_current_rootlist->at(root).GetRootInstance(m_curr_session, &alive);
         if((temp_rootinstance != NULL) && (alive||m_check_show_dead.GetCheck()))
         {  
            for(int curr_rootpoint = 1; curr_rootpoint < temp_rootinstance->points.size(); curr_rootpoint++)
            {
               CPoint pa, pb, temp;
               pa = temp_rootinstance->points.at(curr_rootpoint - 1);
               pb = temp_rootinstance->points.at(curr_rootpoint);

               AdjustPoint(pa);
               AdjustPoint(pb);

               if(pa.x > pb.x)
               {
                  temp = pa;
                  pa = pb;
                  pb = temp;
               }

               double b1, b2, m1, m2, x, y, distance;
               m1 = (double)(pb.y - pa.y) / (double)(pb.x - pa.x);
               m2 = -1 / m1;
               b1 = pa.y - (m1 * pa.x);
               b2 = point.y - (m2 * point.x);
               x = (double)(b2 - b1) / (double)(m1 - m2);
               y = (m1 * x) + b1;
               distance = sqrt((y - point.y) * (y - point.y) + (x - point.x) * (x - point.x));

               if(distance <= 6)
               {
                  if((point.x >= (pa.x - 3)) && (point.x <= (pb.x + 3)))
                  {
                     if(pa.y > pb.y)
                     {
                        temp = pa;
                        pa = pb;
                        pb = temp;
                     }
                     if((point.y >= (pa.y - 3)) && (point.y <= (pb.y + 3)))
                     {
                        return root;
                     }
                  }
               }

               int r;
               pa = temp_rootinstance->diameter_center;
               r = (int)(temp_rootinstance->diameter / 2 / m_image_scale);

               AdjustPoint(pa);

               if((point.x >= (pa.x - r)) && (point.x <= (pa.x + r)) && (point.y >= (pa.y - r)) && (point.y <= (pa.y + r)))
               {
                  return root;
               }
            } // end for: root points
         } // end if: alive and not null
      } // end for: root list
   }
   return -1;
}

int CRootflyDlg::IsOnPoint(CPoint point)
{
   if(IsBitmap(m_image_filename) && (m_selected_root_id >= 0))
   {
      //RootList *temp_rootlist = m_data.m_root.GetRootList(m_curr_tube, m_curr_transect, m_curr_window);
      RootInstance *temp_rootinstance;
      bool alive;

      temp_rootinstance = m_current_rootlist->at(m_selected_root_id).GetRootInstance(m_curr_session, &alive);
      if((temp_rootinstance != NULL) && alive)
      {
         for(int curr_rootpoint = 0; curr_rootpoint < temp_rootinstance->points.size(); curr_rootpoint++)
         {
            CPoint pa;
            pa = temp_rootinstance->points.at(curr_rootpoint);
            AdjustPoint(pa);
            if((point.x >= (pa.x - 4)) && (point.x <= (pa.x + 4)) && (point.y >= (pa.y - 4)) && (point.y <= (pa.y + 4)))
            {
               return curr_rootpoint;
            }
         }
      }
   }
   return -1;
}

bool CRootflyDlg::IsOnDiameter(CPoint point)
{
   if(IsBitmap(m_image_filename) && (m_selected_root_id >= 0))
   {
      //RootList *temp_rootlist = m_data.m_root.GetRootList(m_curr_tube, m_curr_transect, m_curr_window);
      RootInstance *temp_rootinstance;
      bool alive;

      temp_rootinstance = m_current_rootlist->at(m_selected_root_id).GetRootInstance(m_curr_session, &alive);
      if((temp_rootinstance != NULL) && alive)
      {
         CPoint pa;
         int r;
         pa = temp_rootinstance->diameter_center;
         r = (int)(temp_rootinstance->diameter / 2 / m_image_scale);
         AdjustPoint(pa);
         if((point.x >= (pa.x - r)) && (point.x <= (pa.x + r)) && (point.y >= (pa.y - r)) && (point.y <= (pa.y + r)))
         {
            return true;
         }
      }
   }
   return false;
}

bool CRootflyDlg::IsOnDiameterPoint(CPoint point)
{
   if(IsBitmap(m_image_filename) && (m_selected_root_id >= 0))
   {
      //RootList *temp_rootlist = m_data.m_root.GetRootList(m_curr_tube, m_curr_transect, m_curr_window);
      RootInstance *temp_rootinstance;
      bool alive;

      temp_rootinstance = m_current_rootlist->at(m_selected_root_id).GetRootInstance(m_curr_session, &alive);
      if((temp_rootinstance != NULL) && alive)
      {
         CPoint d_center;
         int r;
         d_center = temp_rootinstance->diameter_center;
         r = (int)(temp_rootinstance->diameter / 2 / m_image_scale);
         AdjustPoint(d_center);
         if((point.x >= (d_center.x - 4)) && (point.x <= (d_center.x + 4)) && (point.y >= (d_center.y - r - 4)) && (point.y <= (d_center.y - r + 4)))
         {
            return true;
         }
      }
   }
   return false;  
}

// scales and offsets a point that is going from image -> screen coordinates
// (use this when drawing a point from data to the screen)
void CRootflyDlg::AdjustPoint(CPoint &point)
{
   CPoint session_offset;
	session_offset = m_current_rootlist->offset_list.at(m_curr_session);
   session_offset.x = session_offset.x / m_image_scale;
   session_offset.y = session_offset.y / m_image_scale;

   point.x = point.x / m_image_scale;
   point.y = point.y / m_image_scale; 
   point.Offset(m_image_topleft);
   point.Offset(session_offset);
}

// un-scales and un-offsets a point from screen -> image coordinates
// use this when capturing a mouse movement to store in data
void CRootflyDlg::ReAdjustPoint(CPoint &point)
{
   CPoint session_offset;

   session_offset = m_current_rootlist->offset_list.at(m_curr_session);
   session_offset.x = session_offset.x / m_image_scale * -1;
   session_offset.y = session_offset.y / m_image_scale * -1;
   point.Offset(session_offset);
   point.x = (point.x - m_image_topleft.x) * m_image_scale;
   point.y = (point.y - m_image_topleft.y) * m_image_scale;
}

void CRootflyDlg::ReDraw(int mode, CPoint mouse_location)
{
   if(!IsBitmap(m_image_filename))
   {
      CClientDC dc(this);
      CPen pen(PS_SOLID, 1, RGB(0, 0, 0));
      CRect rect;
      CRect text_location;
      blepo::ImgBgr img;
      img.Reset(640,480);
      blepo::Bgr color(216,233,236);
      blepo::ImgBgr::Iterator it;
      for (it=img.Begin() ; it!=img.End() ; it++)  *it = color;

      m_static_image.GetWindowRect(&rect);
      m_static_image.GetWindowRect(&text_location);
      text_location.top = text_location.top + 160;
      ScreenToClient(&rect);
      CRect src_rect(0, 0, img.Width(), img.Height());
      blepo::Draw(img, dc, src_rect, rect);

      dc.SelectObject(pen);

      if(m_open)
      {
         dc.DrawText("No Image Available",text_location,1);
      }
   }
   else
   {
      CPoint pa, pb;
      CPoint session_offset;

      // setup the regular dc
      CClientDC real_dc(this);
      CRect rect;
      m_static_image.GetWindowRect(&rect);
      ScreenToClient(&rect);
      CRect src_rect(0, 0, m_image.Width(), m_image.Height());

      // set the clip region to stop drawing on other parts of dialog
      CRgn clip_rgn;
      CRect image_rect;
      m_static_image.GetWindowRect(&image_rect);
      ScreenToClient(&image_rect);
      clip_rgn.CreateRectRgnIndirect(&image_rect);
      real_dc.SelectClipRgn(&clip_rgn);

      // convert to a double-buffered dc
      CMemDC dc(&real_dc);

      RootInstance *temp_rootinstance;
      bool alive;

      int radius, d_x, d_y;
      blepo::Draw(m_image, dc, src_rect, rect);

      // create pens and brushes
      CPen pen(PS_SOLID, 1, RGB(255, 0, 0));
      CPen dead_pen(PS_SOLID, 1, RGB(0, 0, 0));
      CPen highlight_pen(PS_SOLID, 1, RGB(0, 255, 0));
      CPen dead_highlight_pen(PS_SOLID, 1, RGB(200, 200, 200));
      CPen select_pen(PS_SOLID, 2, RGB(0, 255, 0));
      CPen dead_select_pen(PS_SOLID, 2, RGB(200, 200, 200));
      CPen point_pen(PS_SOLID, 1, RGB(0, 0, 0));
      CBrush black_brush(RGB(0, 0, 0));
      CBrush lightbrown_brush(RGB(204, 153, 102));
      CBrush darkbrown_brush(RGB(99, 33, 0));
      CBrush white_brush(RGB(255, 255, 255));


      CPen *oldpen = dc.SelectObject(&pen);
      CBrush *old_brush;

	   session_offset = m_current_rootlist->offset_list.at(m_curr_session);
      if (mode == 1)
      {
         session_offset = session_offset + m_temp_offset;
      } //end if mode 1
      session_offset.x = session_offset.x / m_image_scale;
      session_offset.y = session_offset.y / m_image_scale;

      for(int curr_root = 0; curr_root < m_current_rootlist->size(); curr_root++)
      {
         temp_rootinstance = m_current_rootlist->at(curr_root).GetRootInstance(m_curr_session, &alive);
         if(curr_root == m_selected_root_id)
         {
            if (alive)
            {
               oldpen = dc.SelectObject(&select_pen);
            }
            else if (m_check_show_dead.GetCheck())
            {
               oldpen = dc.SelectObject(&dead_select_pen);
            }
         } 
         else if(curr_root == m_highlighted_root_id)
         {
            if (alive)
            {
               oldpen = dc.SelectObject(&highlight_pen);
            }
            else if (m_check_show_dead.GetCheck())
            {
               oldpen = dc.SelectObject(&dead_highlight_pen);
            }
         } //end else if
         else
         {
            if (alive)
            {
               oldpen = dc.SelectObject(&pen);
            }
            else if (m_check_show_dead.GetCheck())
            {
               oldpen = dc.SelectObject(&dead_pen);
            }
         } //end else
         if((temp_rootinstance != NULL) && (alive||m_check_show_dead.GetCheck()))
         {
            for(int curr_point = 1; curr_point < temp_rootinstance->points.size();  curr_point++)
            {
               pa = temp_rootinstance->points.at(curr_point - 1);
               pb = temp_rootinstance->points.at(curr_point);
               pa.x = pa.x / m_image_scale + m_image_topleft.x;
               pa.y = pa.y / m_image_scale + m_image_topleft.y;
               pb.x = pb.x / m_image_scale + m_image_topleft.x;
               pb.y = pb.y / m_image_scale + m_image_topleft.y;
               pa.Offset(session_offset);
               pb.Offset(session_offset);

               dc.MoveTo(pa.x, pa.y);
               dc.LineTo(pb.x, pb.y);

               if(curr_root == m_selected_root_id)
               { 
                  CPen *temp = dc.SelectObject(&point_pen);
                  dc.Rectangle(pa.x - 3, pa.y - 3, pa.x + 3, pa.y + 3);
                  dc.Rectangle(pb.x - 3, pb.y - 3, pb.x + 3, pb.y + 3);
                  dc.SelectObject(temp);
               } //end if
            } //end for

            radius = temp_rootinstance->diameter / 2 / m_image_scale;
            d_x = temp_rootinstance->diameter_center.x / m_image_scale + m_image_topleft.x + session_offset.x;
            d_y = temp_rootinstance->diameter_center.y / m_image_scale + m_image_topleft.y + session_offset.y;
        
            switch (temp_rootinstance->color)
            {
               case COLOR_BLACK:
                  old_brush = dc.SelectObject(&black_brush);
               break;
               case COLOR_DARKBROWN:
                  old_brush = dc.SelectObject(&darkbrown_brush);
               break;
               case COLOR_LIGHTBROWN:
                  old_brush = dc.SelectObject(&lightbrown_brush);
               break;
               case COLOR_WHITE:
                  old_brush = dc.SelectObject(&white_brush);
               break;
               default:
                  old_brush = dc.SelectObject(&darkbrown_brush);
               break;
            } //end switch

            dc.MoveTo(d_x, d_y);
            dc.Ellipse(d_x - radius, d_y - radius, d_x + radius, d_y + radius);
            dc.SelectObject(old_brush);

            if(curr_root == m_selected_root_id)
            {
               CPen *temp = dc.SelectObject(&point_pen);
               dc.Rectangle(d_x - 3, d_y - radius - 3, d_x + 3, d_y - radius + 3);
               dc.SelectObject(temp);
            }

            if (m_check_show_ids.GetCheck())
            {
               CString temp;
               temp.Format("%d",curr_root + 1);
               dc.TextOut(d_x + radius+2, d_y, temp);
            }
         } //end if
         dc.SelectObject(oldpen);
      } //end for

      if ((m_addline && m_number_click > 0) || (m_adddiameter))
      {
         if (m_number_click == 1)
         {
            dc.MoveTo(m_temp_root.points.at(0).x/m_image_scale+m_image_topleft.x+session_offset.x, m_temp_root.points.at(0).y/m_image_scale+m_image_topleft.y+session_offset.y);
         }
         for(int k = 1; k < m_temp_root.points.size(); k++)
         {
            dc.MoveTo(m_temp_root.points.at(k-1).x/m_image_scale+m_image_topleft.x+session_offset.x, m_temp_root.points.at(k-1).y/m_image_scale+m_image_topleft.y+session_offset.y);
            dc.LineTo(m_temp_root.points.at(k).x/m_image_scale+m_image_topleft.x+session_offset.x, m_temp_root.points.at(k).y/m_image_scale+m_image_topleft.y+session_offset.y);
         } //end for

         if (m_addline)
         {
            dc.LineTo(mouse_location.x,mouse_location.y);
         }

         if (m_adddiameter)
         {
            ReAdjustPoint(mouse_location);
            int x_value = m_temp_root.diameter_center.x - mouse_location.x;
            int y_value = m_temp_root.diameter_center.y - mouse_location.y;
            radius = sqrt((double)((x_value * x_value) + (y_value * y_value)));
            d_x = m_temp_root.diameter_center.x/m_image_scale+m_image_topleft.x+session_offset.x;
            d_y = m_temp_root.diameter_center.y/m_image_scale+m_image_topleft.y+session_offset.y;

            old_brush = dc.SelectObject(&white_brush);
            dc.Ellipse(d_x-radius,d_y-radius,d_x+radius,d_y+radius);
            dc.SelectObject(old_brush);
         }
      } //end if


      if (m_extend_end && (m_selected_root_id >= 0))
         {
            bool status;
            int first_or_last;

            RootInstance *temp_rootinstance;
            temp_rootinstance = m_current_rootlist->at(m_selected_root_id).GetRootInstance(m_curr_session,&status);
         
            CPoint adjusted_mouse_location=mouse_location;
            ReAdjustPoint(adjusted_mouse_location);
            first_or_last=DetermineClosestEnd(adjusted_mouse_location,temp_rootinstance);

            dc.MoveTo(temp_rootinstance->points.at(first_or_last).x/m_image_scale+m_image_topleft.x+session_offset.x,temp_rootinstance->points.at(first_or_last).y/m_image_scale+m_image_topleft.y+session_offset.y);
            dc.LineTo(mouse_location.x,mouse_location.y);
         }


      //display properties in the box on the side
      if (m_selected_root_id != -1)
      {
         CString temp;
         RootInstance *temp_root;
         double length;
         bool root_status;

         temp_root = m_current_rootlist->at(m_selected_root_id).GetRootInstance(m_curr_session,&root_status);

         temp.Format("%d",m_selected_root_id+1);
         m_edit_id.SetWindowText(temp);

/* 05/25/06 - JLF; Change to Diameter */
//         temp.Format("%.2lf",temp_root->diameter/m_data.m_mm_conversion);
         temp.Format("%.2lf mm",temp_root->diameter / m_data.m_mm_conversion);  // STB: convert to mm for display
         m_edit_diameter.SetWindowText(temp);
         if (root_status)
         {
            m_edit_diameter.SetReadOnly(false);
            m_combo_color.EnableWindow(true);
            m_button_extend_end.EnableWindow(true);
         }
         else
         {
            m_edit_diameter.SetReadOnly();
            m_combo_color.EnableWindow(false);
            m_button_extend_end.EnableWindow(false);
         }

         m_combo_state.EnableWindow(true);
         m_button_all_dead.EnableWindow(true);

         length = 0;
         for(int k = 1; k < temp_root->points.size(); k++)
         {
            length += sqrt(1.0*(temp_root->points.at(k-1).x-temp_root->points.at(k).x)*(temp_root->points.at(k-1).x-temp_root->points.at(k).x)+1.0*(temp_root->points.at(k-1).y-temp_root->points.at(k).y)*(temp_root->points.at(k-1).y-temp_root->points.at(k).y));
         } //end for
         temp.Format("%.2lf mm",length/m_data.m_mm_conversion);
         m_edit_length.SetWindowText(temp);

         switch (temp_root->color)
         {
            case 0:
               m_combo_color.SetCurSel(1);
            break;
            case 1:
               m_combo_color.SetCurSel(2);
            break;
            case 2:
               m_combo_color.SetCurSel(0);
            break;
            case 3:
               m_combo_color.SetCurSel(3);
            break;
         } //end switch

         switch (root_status)
         {
            case true:
               m_combo_state.SetCurSel(1);
            break;
            case false:
               m_combo_state.SetCurSel(0);
            break;
         } //end switch
      }
      else
      {
         m_edit_id.SetWindowText("");
         m_edit_diameter.SetWindowText("");
         m_edit_diameter.SetReadOnly();
         m_edit_length.SetWindowText("");
         m_combo_color.SetCurSel(-1);
         m_combo_state.SetCurSel(-1);

         m_combo_color.EnableWindow(false);
         m_combo_state.EnableWindow(false);
         m_button_extend_end.EnableWindow(false);
         m_button_all_dead.EnableWindow(false);
      } //end if-else
   } //end if Bitmap
}

void CRootflyDlg::OnOK() 
{
   if(GetFocus() == &m_edit_diameter)
      OnKillfocusEditDiameter();
   else if(GetFocus() == &m_edit_tube)
      OnKillfocusEditTube();
   else if(GetFocus() == &m_edit_transect)
      OnKillfocusEditTransect();
   else if(GetFocus() == &m_edit_window)
      OnKillfocusEditWindow();
   else if(GetFocus() == &m_edit_session)
      OnKillfocusEditSession();
}

void CRootflyDlg::OnKillfocusEditDiameter() 
{
   CString temp;
   RootInstance *temp_root;
   bool root_status;
   float root_diameter;

   if ((m_current_rootlist != NULL)&&(m_selected_root_id != -1))
   {
	   temp_root = m_current_rootlist->at(m_selected_root_id).GetRootInstance(m_curr_session,&root_status);

      m_edit_diameter.GetWindowText(temp);
      root_diameter = atof(temp);

      temp_root->diameter = (int) (root_diameter * m_data.m_mm_conversion);  // STB: convert from mm
      m_data.SetModify();
      UpdateTitleBar();
      ReDraw();
   } //end if
}

void CRootflyDlg::OnKillfocusEditTube() 
{
   CString temp;
   int tube;

	// get edit box data
	m_edit_tube.GetWindowText(temp);
	tube = atoi(temp) - 1;

   if(tube != m_curr_tube)
   {
      if(!ChangeLocation(tube, m_curr_transect, m_curr_window, m_curr_session))
      {
         temp.Format("%d", m_curr_tube + 1);
         m_edit_tube.SetWindowText(temp);
      }    
   }
}

void CRootflyDlg::OnKillfocusEditTransect() 
{
   CString temp;
   int transect;

	// get edit box data
	m_edit_transect.GetWindowText(temp);
   if (temp == "A")
	{
		transect = 0;
	}
	else if (temp == "B")
	{
		transect = 1;
	}
	else if (temp == "C")
	{
		transect = 2;
	}
	else
   {
      temp = "A";
      transect = 0;
   }

   if(transect != m_curr_transect)
   {
      if(!ChangeLocation(m_curr_tube, transect, m_curr_window, m_curr_session))
      {
         m_edit_transect.SetWindowText(temp);
      }
   }
}

void CRootflyDlg::OnKillfocusEditWindow() 
{
   CString temp;
   int window;

	// get edit box data
	m_edit_window.GetWindowText(temp);
	window = atoi(temp) - 1;

   if(window != m_curr_window)
   {
      if(!ChangeLocation(m_curr_tube, m_curr_transect, window, m_curr_session))
      {
         temp.Format("%d", m_curr_window + 1);
         m_edit_window.SetWindowText(temp);
      } 
   }
}


void CRootflyDlg::OnKillfocusEditSession() 
{
   CString temp;
   int session;

	// get edit box data
	m_edit_session.GetWindowText(temp);
	session = atoi(temp) - 1;

   if(session != m_curr_session)
   {
      if(!ChangeLocation(m_curr_tube, m_curr_transect, m_curr_window, session))
      {
         temp.Format("%d", m_curr_session + 1);
         m_edit_session.SetWindowText(temp);
      }
   }
}

void CRootflyDlg::OnSelchangeComboColor() 
{
   CString temp;
   RootInstance *temp_root;
   bool root_status;
   int combo_color_value;

   if ((m_current_rootlist != NULL)&&(m_selected_root_id != -1))
   {
	   temp_root = m_current_rootlist->at(m_selected_root_id).GetRootInstance(m_curr_session,&root_status);

      combo_color_value = m_combo_color.GetCurSel();

      switch (combo_color_value)
      {
         case 0: //black
            temp_root->color = COLOR_BLACK;
         break;
         case 1: //darkbrown
            temp_root->color = COLOR_DARKBROWN;
         break;
         case 2: //lightbrown
            temp_root->color = COLOR_LIGHTBROWN;
         break;
         case 3: //white
            temp_root->color = COLOR_WHITE;
         break;
      } //end switch

      m_data.SetModify();
      UpdateTitleBar();
      ReDraw();
   } //end if
}

void CRootflyDlg::OnSelchangeComboState() 
{
   CString temp;
   RootOverTime *temp_rootovertime;
   int combo_state_value;

   if ((m_current_rootlist != NULL)&&(m_selected_root_id != -1))
   {
	   temp_rootovertime = &(m_current_rootlist->at(m_selected_root_id));

      combo_state_value = m_combo_state.GetCurSel();

      switch (combo_state_value)
      {
         case 0: //dead
            temp_rootovertime->DeclareDead(m_curr_session);
         break;
         case 1: //live
            temp_rootovertime->DeclareDead(m_curr_session,false);
         break;
      } //end switch

      m_data.SetModify();
      UpdateTitleBar();
      ReDraw();
   } //end if	
}

bool CRootflyDlg::ChangeLocation(int tube, int transect, int window, int session)
{ 
   CString new_image_filename;
   int num_tubes, num_transects, num_windows, num_sessions;

   // check to see if there's an image for the new location
//   new_image_filename = m_file_directory + ImageName(m_data.m_image_format, tube+1, (char)(transect+m_ascii_add+1), window+1, session+1);
   new_image_filename = ImageName(m_file_directory, tube+1, window+1, session+1);
   m_data.m_root.GetDimensions(&num_tubes, &num_transects, &num_windows, &num_sessions);
   if(!(IsBitmap(new_image_filename)||((tube<num_tubes)&&(tube>=0)&&(transect<num_transects)&&(transect>=0)&&(window<num_windows)&&(window>=0)&&(session<num_sessions)&&(session>=0))))
   {
      return false;
   }

   // check if coordinates are already in the data structure (no resize)
   if((tube < num_tubes) && (transect < num_transects) && (window < num_windows) && (session < num_sessions))
   {
      if(session == 0)
         m_copy_previous.EnableWindow(false);
      else 
         m_copy_previous.EnableWindow(true);
      
      m_current_rootlist = m_data.m_root.GetRootList(tube,transect,window);
      m_curr_offset = m_current_rootlist->offset_list.at(session); 
      m_curr_tube = tube;
      m_curr_transect = transect;
      if( m_curr_transect == 0 )
      {
         m_edit_transect.SetWindowText("A");
      }
      else if( m_curr_transect == 1 )
      {
         m_edit_transect.SetWindowText("B");
      }
      else if( m_curr_transect == 2 )
      {
         m_edit_transect.SetWindowText("C");
      }
      m_curr_window = window;
      m_curr_session = session;

      m_addline = false;
      m_adddiameter = false;
      m_registering = false;
      m_editing_point = false;
      m_resizing_diameter = false;
      m_moving_diameter = false;
      m_extend_end = false;
      m_number_click = 0;

      m_temp_root.color = COLOR_DARKBROWN;
      m_temp_root.diameter = 0.0;
      m_temp_root.points.clear();

      m_selected_root_id = -1;
      m_highlighted_root_id = -1;
      m_selected_point_id = -1;

      m_image_filename = new_image_filename;
      if(IsBitmap(new_image_filename))
      {
         blepo::Load(m_image_filename, &m_image);
      }
      ReDraw();
      UpdateThumbnails();

      return true;
   }
   // coordinates are out of range, but image exists, so resize everything
   else if(IsBitmap(new_image_filename))
   {
      int max_tubes, max_transects, max_windows, max_sessions;

      // determine the new dimensions
      if(tube < num_tubes)
         max_tubes = num_tubes;
      else
         max_tubes = tube + 1;

      if(transect < num_transects)
         max_transects = num_transects;
      else
         max_transects = transect + 1;

      if(window < num_windows)
         max_windows = num_windows;
      else
         max_windows = window + 1;

      if(session < num_sessions)
         max_sessions = num_sessions;
      else
         max_sessions = session + 1;

      // resize data structure
      m_data.m_root.SetDimensions(max_tubes, max_transects, max_windows, max_sessions);

      // reset spin ranges
      m_spin_tube.SetRange32(1, max_tubes);
      m_spin_transect.SetRange32(1, max_transects);
      m_spin_window.SetRange32(1, max_windows);
      m_spin_session.SetRange32(1, max_sessions);

      // set current tube, transect, window, session data
      m_current_rootlist = m_data.m_root.GetRootList(tube,transect,window);
      m_curr_offset = m_current_rootlist->offset_list.at(session); 
      m_curr_tube = tube;
      m_curr_transect = transect;
      if( m_curr_transect == 0 )
      {
         m_edit_transect.SetWindowText("A");
      }
      else if( m_curr_transect == 1 )
      {
         m_edit_transect.SetWindowText("B");
      }
      else if( m_curr_transect == 2 )
      {
         m_edit_transect.SetWindowText("C");
      }
      m_curr_window = window;
      m_curr_session = session;

      // reset action variables
      m_addline = false;
      m_adddiameter = false;
      m_registering = false;
      m_editing_point = false;
      m_resizing_diameter = false;
      m_moving_diameter = false;
      m_number_click = 0;

      m_temp_root.color = COLOR_DARKBROWN;
      m_temp_root.diameter = 0.0;
      m_temp_root.points.clear();

      m_selected_root_id = -1;
      m_highlighted_root_id = -1;
      m_selected_point_id = -1;

      m_image_filename = new_image_filename;
      blepo::Load(m_image_filename, &m_image);
      ReDraw();
      UpdateThumbnails();
      return true;
   }
   return false;
}


//////////////////////////////////////////////////////////////
// This function is called every time the app switches tube/trans/window/session
//////////////////////////////////////////////////////////////
void CRootflyDlg::UpdateThumbnails()
{
   int tube, window, trans, session;
   int tu, tr, wn, sn;

//   if (m_curr_tube < 0  || m_curr_window < 0 || m_curr_session < 0)  return;

   tube = m_curr_tube + 1;
   window = m_curr_window + 1;
   trans = m_curr_transect + 1;
   session = m_curr_session + 1;
   CString temp_str;
   CPoint corner;

   //Get upper limits
   m_data.m_root.GetDimensions(&tu, &tr, &wn, &sn);

   //Mini pic processing
   CString miniFileName;
   CRect rect;
   CClientDC dc(this);
   int i;

   for(i = -2; i < 3; i++) //Window picture loop
   {
//	  miniFileName = m_file_directory+ImageName(m_data.m_image_format,tube,(char)(trans+m_ascii_add),window+i,session);
	  miniFileName = ImageName(m_file_directory, tube, window+i, session);
	   m_Window_Pics[i+2].Reset();

      if (i==0)
      {
         m_Transect_Pict_3.GetWindowRect(&rect);
         ScreenToClient(&rect);
         CPen pen(PS_SOLID, 3, RGB(0, 150, 255));
      
         CPen *oldpen = dc.SelectObject(&pen);

         dc.MoveTo(rect.left-2,rect.top-2);
         dc.LineTo(rect.right+1,rect.top-2);
         dc.LineTo(rect.right+1,rect.bottom+1);
         dc.LineTo(rect.left-2,rect.bottom+1);
         dc.LineTo(rect.left-2,rect.top-2);

         dc.SelectObject(oldpen);
      }

      if(IsBitmap(miniFileName))
      {
         blepo::Load(miniFileName, &m_Window_Pics[i+2]);
         switch(i+2)
         {
            case 0:
               m_Transect_Pict_1.GetWindowRect(&rect);
            break;
            case 1:
               m_Transect_Pict_2.GetWindowRect(&rect);
            break;
            case 2:
               m_Transect_Pict_3.GetWindowRect(&rect);
            break;
            case 3:
               m_Transect_Pict_4.GetWindowRect(&rect);
            break;
            case 4:
               m_Transect_Pict_5.GetWindowRect(&rect);
            break;
         }
         ScreenToClient(&rect);
         CRect src_rect(0, 0, m_Window_Pics[i+2].Width(), m_Window_Pics[i+2].Height());
         blepo::Draw(m_Window_Pics[i+2], dc, src_rect, rect);
         corner = rect.TopLeft();
         temp_str.Format("%d", i + m_curr_window + 1);
         dc.TextOut(corner.x+1, corner.y+1, temp_str);
      }
      else
      {
        switch(i+2)
         {
            case 0:
               m_Transect_Pict_1.GetWindowRect(&rect);
            break;
            case 1:
               m_Transect_Pict_2.GetWindowRect(&rect);
            break;
            case 2:
               m_Transect_Pict_3.GetWindowRect(&rect);
            break;
            case 3:
               m_Transect_Pict_4.GetWindowRect(&rect);
            break;
            case 4:
               m_Transect_Pict_5.GetWindowRect(&rect);
            break;
         }
         ScreenToClient(&rect);
         CPen pen(PS_SOLID, 1, RGB(0, 0, 0));
         CPen *oldpen = dc.SelectObject(&pen);
         CBrush brush(RGB(236,233,216));
         CBrush *oldbrush = dc.SelectObject(&brush);
         dc.Rectangle(rect.left,rect.top,rect.right,rect.bottom);
         dc.SelectObject(oldpen);
         dc.SelectObject(oldbrush);
         if(i+m_curr_window >= 0 && i+m_curr_window < wn)
         {
            corner = rect.TopLeft();
            temp_str.Format("%d", i + m_curr_window + 1);
            dc.TextOut(corner.x+1, corner.y+1, temp_str);
         }
      }

   }//end window picture for loop

   for(i = -2; i < 3; i++) //Session picture loop
   {
//      miniFileName = m_file_directory+ImageName(m_data.m_image_format,tube,(char)(trans+m_ascii_add),window,session+i);
      miniFileName = ImageName(m_file_directory, tube, window, session+i);
      if (i==0)
      {
         m_Session_Pict_3.GetWindowRect(&rect);
         ScreenToClient(&rect);
         CPen pen(PS_SOLID, 3, RGB(0, 150, 255));
      
         CPen *oldpen = dc.SelectObject(&pen);

         dc.MoveTo(rect.left-2,rect.top-2);
         dc.LineTo(rect.right+1,rect.top-2);
         dc.LineTo(rect.right+1,rect.bottom+1);
         dc.LineTo(rect.left-2,rect.bottom+1);
         dc.LineTo(rect.left-2,rect.top-2);

         dc.SelectObject(oldpen);
      }

      if(IsBitmap(miniFileName))
      {
         blepo::Load(miniFileName, &m_Session_Pics[i+2]);
         switch(i+2)
         {
            case 0:
               m_Session_Pict_1.GetWindowRect(&rect);
               break;
            case 1:
               m_Session_Pict_2.GetWindowRect(&rect);
               break;
            case 2:
               m_Session_Pict_3.GetWindowRect(&rect);
               break;
            case 3:
               m_Session_Pict_4.GetWindowRect(&rect);
               break;
            case 4:
               m_Session_Pict_5.GetWindowRect(&rect);
               break;
         }
         ScreenToClient(&rect);
         CRect src_rect(0, 0, m_Session_Pics[i+2].Width(), m_Session_Pics[i+2].Height());
         blepo::Draw(m_Session_Pics[i+2], dc, src_rect, rect);
         corner = rect.TopLeft();
         temp_str.Format("%d", i + m_curr_session + 1);
         dc.TextOut(corner.x+1, corner.y+1, temp_str);
      }
      else
      {
         switch(i+2)
         {
            case 0:
               m_Session_Pict_1.GetWindowRect(&rect);
            break;
            case 1:
               m_Session_Pict_2.GetWindowRect(&rect);
            break;
            case 2:
               m_Session_Pict_3.GetWindowRect(&rect);
            break;
            case 3:
               m_Session_Pict_4.GetWindowRect(&rect);
            break;
            case 4:
               m_Session_Pict_5.GetWindowRect(&rect);
            break;
         }
         ScreenToClient(&rect);
         CPen pen(PS_SOLID, 1, RGB(0, 0, 0));
         CPen *oldpen = dc.SelectObject(&pen);
         CBrush brush(RGB(236,233,216));
         CBrush *oldbrush = dc.SelectObject(&brush);
         dc.Rectangle(rect.left,rect.top,rect.right,rect.bottom);
         dc.SelectObject(oldpen);
         dc.SelectObject(oldbrush);
         if(i+m_curr_session >= 0 && i+m_curr_session < sn)
         {
            corner = rect.TopLeft();
            temp_str.Format("%d", i + m_curr_session + 1);
            dc.TextOut(corner.x+1, corner.y+1, temp_str);
         }
      }

   }// end session picture for loop
}

// ----------------------------------------------------------------------------------------------------------

void CRootflyDlg::OnCopyPrevious() 
{
   RootInstance *temp_rootinstance;
   bool alive;
   if((m_curr_session > 0) && IsBitmap(m_image_filename))
   {
      for(int root_num=0; root_num < m_current_rootlist->size(); root_num++)
      {
         temp_rootinstance = m_current_rootlist->at(root_num).GetRootInstance(m_curr_session - 1, &alive);
         if((temp_rootinstance != NULL) && alive)
         {
            m_current_rootlist->at(root_num).SetRootInstance(m_curr_session, *temp_rootinstance);
         }
      }
   }
   ReDraw();

} // OnCopyPrevious()

// ----------------------------------------------------------------------------------------------------------

void CRootflyDlg::OnCheckShowDead() 
{
   ReDraw();
} // OnCheckShowDead()

// ----------------------------------------------------------------------------------------------------------

// compile a list of all the filenames in the directory with the given extension
void FindAllFilesInDirectory(const CString& dir, const CString& extension, std::vector<CString>* fnames)
{
  fnames->clear();
  CFileFind finder;
  CString temp_string;

  int bResult = finder.FindFile(dir + extension);

  //scan the directory for images
  while(bResult != 0)
  {
    bResult = finder.FindNextFile();
    temp_string = finder.GetFileTitle();
    fnames->push_back(temp_string);
  }
  finder.Close();
} // FindAllFilesInDirectory()

// ----------------------------------------------------------------------------------------------------------

// returns 'true' if filename matches desired file format
// (Bartz format)  -- STB 5/09/06
bool CheckFormatOfImageFilename(const CString& fname)
{
  int i = 0;
  i = fname.Find('_', i);
  if (i == -1)  return false;
  // tube
  if (fname[++i] != 'T')  return false;
  if (!isdigit(fname[++i]))  return false;
  if (!isdigit(fname[++i]))  return false;
  if (!isdigit(fname[++i]))  return false;
  // window
  if (fname[++i] != '_')  return false;
  if (fname[++i] != 'L')  return false;
  if (!isdigit(fname[++i]))  return false;
  if (!isdigit(fname[++i]))  return false;
  if (!isdigit(fname[++i]))  return false;
  // year
  if (fname[++i] != '_')  return false;
  if (!isdigit(fname[++i]))  return false;
  if (!isdigit(fname[++i]))  return false;
  if (!isdigit(fname[++i]))  return false;
  if (!isdigit(fname[++i]))  return false;
  // month
  if (fname[++i] != '.')  return false;
  if (!isdigit(fname[++i]))  return false;
  if (!isdigit(fname[++i]))  return false;
  // day
  if (fname[++i] != '.')  return false;
  if (!isdigit(fname[++i]))  return false;
  if (!isdigit(fname[++i]))  return false;
  // timestamp
  if (fname[++i] != '_')  return false;
  if (!isdigit(fname[++i]))  return false;
  if (!isdigit(fname[++i]))  return false;
  if (!isdigit(fname[++i]))  return false;
  if (!isdigit(fname[++i]))  return false;
  if (!isdigit(fname[++i]))  return false;
  if (!isdigit(fname[++i]))  return false;
  // unknown number (duplicate?)
  if (fname[++i] != '_')  return false;
  if (!isdigit(fname[++i]))  return false;
  if (!isdigit(fname[++i]))  return false;
  if (!isdigit(fname[++i]))  return false;
  // operator initials
  if (fname[++i] != '_')  return false;
  if (!isalpha(fname[++i]))  return false;
  if (!isalpha(fname[++i]))  return false;
  if (!isalpha(fname[++i]))  return false;

  return true;

} // CheckFormatOfImageFilename

// ----------------------------------------------------------------------------------------------------------

// returns 'true' if filename matches desired file format
// (Bartz format)  -- STB 5/09/06
bool ParseImageFilename(const CString& fname, int* tube, int* window, Date* date)
{
  if (CheckFormatOfImageFilename(fname) == false)  return false;

  CString tmp;
  int i; 

  // get tube
  i = fname.Find("_T", 0);
  tmp = fname.Mid(i+2, 3);
  *tube = atoi(tmp);

  // get window
  i = fname.Find("_L", i);
  tmp = fname.Mid(i+2, 3);
  *window = atoi(tmp);

  // get date
  tmp = fname.Mid(i+6, 4);
  date->year = atoi(tmp);
  tmp = fname.Mid(i+11, 2);
  date->month = atoi(tmp);
  tmp = fname.Mid(i+14, 2);
  date->day = atoi(tmp);

  return true;
} // ParseImageFilename()

// ----------------------------------------------------------------------------------------------------------

// Takes in date and returns the session number
int GetSessionFromDate(const Date& date, Session_Array* m_session_array)
{

  int session;

  session = m_session_array->add_date(date);

  session++;

  //return 1;
  return session;
  
} // GetSessionFromDate()

// ----------------------------------------------------------------------------------------------------------

// Bartz format -- STB 5/09/06
bool CRootflyDlg::ScanDirectory()
{
  int max_tube=0, max_window=0, max_session=0;
  int first_tube=0, first_window=0, first_session=0, first_transect=1;
  bool dir_modified = false;

  std::vector<CString> fnames;

/* 05/19/06 - Check if Directory exist: if it doesn't get it */
  int valid_directory = _chdir(m_file_directory);  // Check for valid directory

  if(valid_directory)
  {
// Get new Directory Location
   CFolderDialog dlg(_T("Invalid Directory. Choose Folder where Images are Located" ), m_file_directory, this);
   if(dlg.DoModal() == IDOK)
   {
      m_file_directory = dlg.GetFolderPath();
      m_file_directory = m_file_directory + "\\";
      m_data.m_image_directory = m_file_directory;
      dir_modified = true;
   }
   else
   {
     return dir_modified;
   }
  }

  FindAllFilesInDirectory(m_file_directory, "*.jpg", &fnames);

/* 05/19/06 - Check if there were any files; if not, prompt for new
 *    directory
 */
  int fnames_length = fnames.size();

  while(fnames_length == 0)
  {
// Get new Directory Location
   CFolderDialog dlg(_T("No Images Found. Choose Folder where Images are Located" ), m_file_directory, this);
   if(dlg.DoModal() == IDOK)
   {
      m_file_directory = dlg.GetFolderPath();
      m_file_directory = m_file_directory + "\\";
	    m_data.m_image_directory = m_file_directory;
      dir_modified = true;
   }
   else{
     break;
   }
   FindAllFilesInDirectory(m_file_directory, "*.jpg", &fnames);
   fnames_length = fnames.size();
  }


  for (int i=0 ; i < fnames.size() ; i++)
  {
    int tube, window;
    Date date;
    bool meets_format = ParseImageFilename(fnames[i], &tube, &window, &date);
    if (meets_format)
    {
       int session = GetSessionFromDate(date, &m_session_array);
       if (tube > max_tube)  max_tube = tube;
       if (window > max_window)  max_window = window;
       if (session > max_session)  max_session = session;
       if (first_tube == 0)  first_tube = tube;
       if (first_window == 0)  first_window = window;
       if (first_session == 0)  first_session = session;
    }
  }

  int max_transect = 1;
  m_data.m_root.SetDimensions(max_tube,max_transect,max_window, max_session);

  //set the spinbutton range and initial position.
  // display the first image whose name saved in the m_filenames.
  CString temp_string;
  if(( first_tube != 0)&&(max_tube > 0))
  {
    //set the current image
    m_curr_tube = first_tube - 1;
    m_curr_transect = first_transect - 1;
    m_curr_window = first_window - 1;
    m_curr_session = first_session - 1;

    m_spin_session.EnableWindow(true); 
    m_spin_tube.EnableWindow(true);
    m_spin_window.EnableWindow(true);
    m_spin_transect.EnableWindow(true);

    m_spin_tube.SetRange32(1,max_tube);
    m_spin_tube.SetPos(first_tube);
    m_spin_transect.SetRange32(1,max_transect);
    m_spin_transect.SetPos(first_transect);
    temp_string.Format("%c", (char)first_transect+64);
    m_edit_transect.SetWindowText(temp_string);
    m_spin_window.SetRange32(1,max_window);
    m_spin_window.SetPos(first_window);
    m_spin_session.SetRange32(1,max_session);
    m_spin_session.SetPos(first_session);

    m_new_root_control.EnableWindow(true);
    m_register_control.EnableWindow(true);

    m_edit_tube.EnableWindow(true);
    m_edit_transect.EnableWindow(true);
    m_edit_window.EnableWindow(true);
    m_edit_session.EnableWindow(true);
    m_spin_tube.Invalidate();
    m_spin_transect.Invalidate();
    m_spin_window.Invalidate();
    m_spin_session.Invalidate();

    m_edit_tube.SetReadOnly(false);
    m_edit_transect.SetReadOnly(false);
    m_edit_window.SetReadOnly(false);
    m_edit_session.SetReadOnly(false);
    
    m_current_rootlist = m_data.m_root.GetRootList(m_curr_tube,m_curr_transect,m_curr_window);
    m_data.m_version = "Rootfly_11";

    // This line needs to be changed for Bartz !!!!
//    m_image_filename = m_file_directory + ImageName(m_data.m_image_format,m_curr_tube+1,(char)m_curr_transect+m_ascii_add+1,m_curr_window+1,m_curr_session+1);
    m_image_filename = ImageName(m_file_directory, m_curr_tube+1, m_curr_window+1, m_curr_session+1);

    if(IsBitmap(m_image_filename))
    {
      blepo::Load(m_image_filename, &m_image);
      ReDraw();
    } //end if
    UpdateThumbnails();

    m_addline = false;
    m_adddiameter = false;
    m_registering = false;
    m_extend_end = false;
    m_number_click = 0;
    m_temp_root.color = COLOR_DARKBROWN;
    m_temp_root.diameter = 0.0;
    m_temp_root.points.clear();
  }//end if there was an image
  else
  {
    m_number_click = 0;
    m_image_filename = "";
    m_addline = false;
    m_adddiameter = false;
    m_registering = false;
    m_editing_point = false;
    m_resizing_diameter = false;
    m_moving_diameter = false;
    m_extend_end = false;
    m_selected_root_id = -1;
    m_have_set_default_image_format = false;
    m_check_show_dead.SetCheck(1);
    m_check_show_ids.SetCheck(1);

    m_curr_tube = -1;
    m_spin_tube.SetRange32(0,0);
    m_spin_tube.SetPos(0);
    m_spin_tube.EnableWindow(false);
    m_edit_tube.EnableWindow(false);

    m_curr_transect = -1;
    m_spin_transect.SetRange32(0,0);
    m_spin_transect.SetPos(0);
    m_edit_transect.SetWindowText("--");
    m_spin_transect.EnableWindow(false);
    m_edit_transect.EnableWindow(false);

    m_curr_window = -1;
    m_spin_window.SetRange32(0,0);
    m_spin_window.SetPos(0);
    m_spin_window.EnableWindow(false);
    m_edit_window.EnableWindow(false);

    m_curr_session = -1;
    m_spin_session.SetRange32(0,0);
    m_spin_session.SetPos(0);
    m_spin_session.EnableWindow(false);
    m_edit_session.EnableWindow(false);

    ReDraw();
    UpdateThumbnails();
  }

  return dir_modified;
}//end ScanDirectory

// ----------------------------------------------------------------------------------------------------------

// Earlier format (prior to Bartz) -- STB 5/09/06
//void CRootflyDlg::ScanDirectory()
//{
//  //scan the directory for the images
//  //load them into the filenames structure 
//  //then resize the root struction
//  CFileFind finder;
//  //CString directory_path, temp_string, format = m_data.m_image_format + ".bmp";
//  CString directory_path, temp_string, format = m_data.m_image_format + ".jpg";
//  int i, j, k, temp_int;
//  int first_tube=0, first_transect=0, first_window=0, first_session=0;
//  int max_tube=0, max_transect=0, max_window=0, max_session=0;
//  char temp_char;
//  //int bResult = finder.FindFile(m_file_directory + "*.bmp");
//  int bResult = finder.FindFile(m_file_directory + "*.jpg");
//  bool bad_file;
//
//  //scan the directory for images
//  while(bResult != 0)
//  {
//    bResult = finder.FindNextFile();
//    temp_string = finder.GetFileTitle();
//    bad_file = false;
//    i = j = 0;
//
//    if(temp_string.GetLength() != format.GetLength()-9)
//      continue;
//
//    while(format.GetAt(i) != '%' && !bad_file)
//    {
//      if(format.GetAt(i) != temp_string.GetAt(i))
//        bad_file = true;
//      i++;
//    }
//
//    if(bad_file)
//      continue;
//
//    //Get first parameter
//    j = i;
//    for(k=0; k < 4; k++)
//    {
//      i += 2;
//      temp_char = format.GetAt(i);
//      if(temp_string.GetAt(j) == '_' || temp_string.GetAt(j) == '-') j++;
//
//      //Determine parameter and update max if needed
//      switch(temp_char)
//      {
//        case 'S':
//          temp_int = atoi(temp_string.Mid(j, 2));
//          j+=2;
//          if(temp_int > max_session) max_session = temp_int;
//          if(first_session == 0) first_session = temp_int;
//          break;
//
//        case 'T':
//          temp_char = temp_string.GetAt(j);
//          switch(temp_char)
//          {
//             case 'A':
//             case 'B':
//             case 'C':
//                temp_int = (int)temp_char - 64;
//                m_ascii_add = 64;
//                break;
//             case 'a':
//             case 'b':
//             case 'c':
//                temp_int = (int)temp_char - 96;
//                m_ascii_add = 96;
//                break;
//          }
//          j++;
//          if(temp_int > max_transect) max_transect = temp_int;
//          if(first_transect == 0) first_transect = temp_int;
//          break;
//
//        case 'U':
//          temp_int = atoi(temp_string.Mid(j, 2));
//          j+=2;
//          if(temp_int > max_tube) max_tube = temp_int;
//          if(first_tube == 0) first_tube = temp_int;
//          break;
//
//        case 'W':
//          temp_int = atoi(temp_string.Mid(j, 2));
//          j+=2;
//          if(temp_int > max_window) max_window = temp_int;
//          if(first_window == 0) first_window = temp_int;
//          break;
//      } // end switch temp_char
//
//      i = format.Find('%', i);
//    } //end for loop parameter retriever
//  } //end while nextfile
//  finder.Close();
//
//  //resize the data structure
//  m_data.m_root.SetDimensions(max_tube,max_transect,max_window, max_session);
//
//  //set the spinbutton range and initial position.
//  // display the first image whose name saved in the m_filenames.
//  if(( first_tube != 0)&&(max_tube > 0))
//  {
//    //set the current image
//    m_curr_tube = first_tube - 1;
//    m_curr_transect = first_transect - 1;
//    m_curr_window = first_window - 1;
//    m_curr_session = first_session - 1;
//
//    m_spin_session.EnableWindow(true); 
//    m_spin_tube.EnableWindow(true);
//    m_spin_window.EnableWindow(true);
//    m_spin_transect.EnableWindow(true);
//
//    m_spin_tube.SetRange32(1,max_tube);
//    m_spin_tube.SetPos(first_tube);
//    m_spin_transect.SetRange32(1,max_transect);
//    m_spin_transect.SetPos(first_transect);
//    temp_string.Format("%c", (char)first_transect+64);
//    m_edit_transect.SetWindowText(temp_string);
//    m_spin_window.SetRange32(1,max_window);
//    m_spin_window.SetPos(first_window);
//    m_spin_session.SetRange32(1,max_session);
//    m_spin_session.SetPos(first_session);
//
//    m_new_root_control.EnableWindow(true);
//    m_register_control.EnableWindow(true);
//
//    m_edit_tube.EnableWindow(true);
//    m_edit_transect.EnableWindow(true);
//    m_edit_window.EnableWindow(true);
//    m_edit_session.EnableWindow(true);
//    m_spin_tube.Invalidate();
//    m_spin_transect.Invalidate();
//    m_spin_window.Invalidate();
//    m_spin_session.Invalidate();
//
//    m_edit_tube.SetReadOnly(false);
//    m_edit_transect.SetReadOnly(false);
//    m_edit_window.SetReadOnly(false);
//    m_edit_session.SetReadOnly(false);
//    
//    m_current_rootlist = m_data.m_root.GetRootList(m_curr_tube,m_curr_transect,m_curr_window);
//    m_data.m_version = "Rootfly_3";
//    m_image_filename = m_file_directory + ImageName(m_data.m_image_format,m_curr_tube+1,(char)m_curr_transect+m_ascii_add+1,m_curr_window+1,m_curr_session+1);
//
//    if(IsBitmap(m_image_filename))
//    {
//      blepo::Load(m_image_filename, &m_image);
//      ReDraw();
//    } //end if
//    UpdateThumbnails();
//
//    m_addline = false;
//    m_adddiameter = false;
//    m_registering = false;
//    m_extend_end = false;
//    m_number_click = 0;
//    m_temp_root.color = COLOR_DARKBROWN;
//    m_temp_root.diameter = 0.0;
//    m_temp_root.points.clear();
//  }//end if there was an image
//  else
//  {
//    m_number_click = 0;
//    m_image_filename = "";
//    m_addline = false;
//    m_adddiameter = false;
//    m_registering = false;
//    m_editing_point = false;
//    m_resizing_diameter = false;
//    m_moving_diameter = false;
//    m_extend_end = false;
//    m_selected_root_id = -1;
//    m_have_set_default_image_format = false;
//    m_check_show_dead.SetCheck(1);
//    m_check_show_ids.SetCheck(1);
//
//    m_curr_tube = -1;
//    m_spin_tube.SetRange32(0,0);
//    m_spin_tube.SetPos(0);
//    m_spin_tube.EnableWindow(false);
//    m_edit_tube.EnableWindow(false);
//
//    m_curr_transect = -1;
//    m_spin_transect.SetRange32(0,0);
//    m_spin_transect.SetPos(0);
//    m_edit_transect.SetWindowText("--");
//    m_spin_transect.EnableWindow(false);
//    m_edit_transect.EnableWindow(false);
//
//    m_curr_window = -1;
//    m_spin_window.SetRange32(0,0);
//    m_spin_window.SetPos(0);
//    m_spin_window.EnableWindow(false);
//    m_edit_window.EnableWindow(false);
//
//    m_curr_session = -1;
//    m_spin_session.SetRange32(0,0);
//    m_spin_session.SetPos(0);
//    m_spin_session.EnableWindow(false);
//    m_edit_session.EnableWindow(false);
//
//    ReDraw();
//    UpdateThumbnails();
//  }
//}//end ScanDirectory

// ----------------------------------------------------------------------------------------------------------

void CRootflyDlg::OnButtonAllDead() 
{
  CString temp_str;
  temp_str.Format("Delete root from all sessions?\r\nAll root #%d data will be lost.", m_selected_root_id+1);

  if(AfxMessageBox(temp_str, MB_YESNO) == IDYES)
  {
    RootOverTime *temp_rootovertime;

    //Get current rootlist
    temp_rootovertime = &(m_current_rootlist->at(m_selected_root_id));

    //Declare dead and update window
    temp_rootovertime->DeclareDead(m_curr_session, true, true);
    m_selected_root_id = -1;
    m_data.SetModify();
    UpdateTitleBar();
    ReDraw(); 
  }
}

void CRootflyDlg::OnCheckShowIds() 
{
	ReDraw();	
}

//Exports the data structure to a .csv file
void CRootflyDlg::OnExport() 
{
   //make sure the data structure is saved before exporting
   int return_value;
   if(m_data.GetModify())
   {
      return_value = AfxMessageBox("Project data has changed. Save changes?",MB_YESNOCANCEL);

      if(return_value == IDYES)
      {
         OnSave();//call the save function if things have changed 
      }
      else if(return_value == IDCANCEL)
      {
         return;
      }
   }

   //start exporting to the .csv file
   CFileDialog fldg(FALSE,"csv",NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,"Excel Files(*.csv)|*.csv|All Files(*.*)|*.*||",this);

   if(m_open)
   {
      if(fldg.DoModal() == IDOK)
      {
         m_filename = fldg.GetPathName();
         m_data.Export(m_filename);
         m_data.SetModify(false);
         UpdateTitleBar();
      }
   }
   else
      AfxMessageBox("No file open.");
}

void CRootflyDlg::OnCopySession() 
{
   RootInstance *temp_rootinstance;
   RootList *temp_rootlist;
   CString temp_filename;
   int num_tubes, num_trans, num_winds, num_sess;
   bool alive;

   m_data.m_root.GetDimensions(&num_tubes, &num_trans, &num_winds, &num_sess);

   CCopySession dlg(m_curr_session, num_sess);
   if(dlg.DoModal() == IDOK)
   {
      int curr_sess = dlg.GetCurrentSession();
      int prev_sess = dlg.GetPreviousSession();

      if(curr_sess < num_sess && prev_sess < num_sess && curr_sess >= 0 && prev_sess >= 0 && prev_sess < curr_sess)
      {
         if(CheckForRoots(curr_sess, prev_sess, num_tubes, num_trans, num_winds))
         {
            for(int t=0; t < num_tubes; t++)
            {
               for(int r=0; r < num_trans; r++)
               {
                  for(int w=0; w < num_winds; w++)
                  {
//                     temp_filename = m_file_directory + ImageName(m_data.m_image_format, t+1, (char)(r+m_ascii_add+1), w+1, prev_sess+1);
                     temp_filename = ImageName(m_file_directory, t+1, w+1, prev_sess+1);
					  if(IsBitmap(temp_filename))
                     {
                        temp_rootlist = m_data.m_root.GetRootList(t, r, w);
                        for(int root_num=0; root_num < temp_rootlist->size(); root_num++)
                        {
                           for(int i=prev_sess+1; i <= curr_sess; i++)
                           {
                              temp_rootinstance = temp_rootlist->at(root_num).GetRootInstance(i-1, &alive);
                              if((temp_rootinstance != NULL) && alive)
                                 temp_rootlist->at(root_num).SetRootInstance(i, *temp_rootinstance);
                           } //end i loop
                        } //end root data loop
                     } //end if IsBitmap
                  } //end window loop
               } //end transect loop
            } //end tube loop
            ReDraw();
         } //end if CheckForRoots
      } //end if
      else
         AfxMessageBox("One of the sessions entered is invalid.\r\nData will not be transferred");
   }
}

bool CRootflyDlg::CheckForRoots(int curr_sess, int prev_sess, int tu, int tr, int wn)
{
   RootInstance *temp_rootinstance;
   RootList *temp_rootlist;
   CString temp_filename;
   bool alive;

   for(int t=0; t < tu; t++)
   {
      for(int r=0; r < tr; r++)
      {
         for(int w=0; w < wn; w++)
         {
            temp_rootlist = m_data.m_root.GetRootList(t, r, w);
            for(int root_num=0; root_num < temp_rootlist->size(); root_num++)
            {
               for(int i=prev_sess+1; i <= curr_sess; i++)
               {
                  temp_rootinstance = temp_rootlist->at(root_num).GetRootInstance(i, &alive);
                  if((temp_rootinstance != NULL) && alive)
                  {
                     if(AfxMessageBox("Some roots already exist in the given range.\r\nContinuing will overwrite the current data.\r\nContinue?", MB_YESNO | MB_ICONQUESTION) == IDYES)
                        return true;
                     else
                        return false;
                  }
               }
            }
         }
      }
   }

   return true;
}

void CRootflyDlg::OnButtonExtendEnd() 
{
   if(m_open)
   {
      m_extend_end = true;
      m_registering = false;
      m_addline = false;
      m_adddiameter = false;
   }
}

int CRootflyDlg::DetermineClosestEnd(CPoint mouse, RootInstance *current)
{
  CPoint first,end;
  int close_to_first,close_to_last;
  int last;

  last=current->points.size()-1;
  first=current->points.at(0); 
  end=current->points.at(last);

  ReAdjustPoint(mouse);
  ReAdjustPoint(first);
  ReAdjustPoint(end);

  double fpx=first.x-mouse.x;
  double fpy=first.y-mouse.y;
  double epx=end.x-mouse.x;
  double epy=end.y-mouse.y;
  close_to_first=sqrt(fpx*fpx+fpy*fpy);
  close_to_last=sqrt(epx*epx+epy*epy);

  if (close_to_first<close_to_last)
    return 0;
  else
    return last;
}

void CRootflyDlg::OnMmConversion() 
{
  CFileDialog dlg(TRUE, "jpg", NULL, OFN_HIDEREADONLY, "JPEG Files (*.jpg)|*.jpg|Bitmap Files (*.bmp)|*.bmp|All Files (*.*)|*.*|");  
  dlg.m_ofn.lpstrTitle = "Load calibration image";
  int ret = dlg.DoModal();
  if (ret == IDOK)
  {
    CalibrationDialog calib(dlg.GetFileName(), m_data.m_mm_conversion);
    ret = calib.DoModal();
    if (ret == IDOK)
    {
      m_data.m_mm_conversion = calib.GetConversion();
      m_data.SetModify(true);
      UpdateTitleBar();
      UpdatePixelsPerMmDisplay();
    }
  }
  ReDraw();

// old:
//   //m_data.m_mm_conversion = 1;
//   mmConversion mmdialog(m_data.m_mm_conversion);
//
//   if(mmdialog.DoModal() == IDOK)
//   {
//      m_data.m_mm_conversion = mmdialog.GetConversion();
//      m_data.SetModify(true);
//      UpdateTitleBar();
//   }
//   ReDraw();
}

// ----------------------------------------------------------------------------------------------------------

void CRootflyDlg::OnChangeDirectory()
{

   CFolderDialog dlg(_T("Invalid Directory. Choose Folder where Images are Located" ), m_file_directory, this);
   if(dlg.DoModal() == IDOK)
   {
      m_file_directory = dlg.GetFolderPath();
      m_file_directory = m_file_directory + "\\";
      m_data.m_image_directory = m_file_directory;
      bool result = ScanDirectory();
      m_data.SetModify(result);
   }

} // OnChangeDirectory()

// ----------------------------------------------------------------------------------------------------------

void CRootflyDlg::OnHelpAboutrootfly() 
{
  CAboutDlg dlgAbout;
  dlgAbout.DoModal();
}

// ---------------------------------------------------------------------------------------------------------------------

// OnEditDeleteroot: Deletes root, called from Edit Menu
//    TODO: Redirect to call orginal delete root function
void CRootflyDlg::OnEditDeleteroot() 
{

  CString temp_str;
  temp_str.Format("Delete root from all sessions?\r\nAll root #%d data will be lost.", m_selected_root_id+1);

  if(AfxMessageBox(temp_str, MB_YESNO) == IDYES)
  {
    RootOverTime *temp_rootovertime;

    //Get current rootlist
    temp_rootovertime = &(m_current_rootlist->at(m_selected_root_id));

    //Declare dead and update window
    temp_rootovertime->DeclareDead(m_curr_session, true, true);
    m_selected_root_id = -1;
    m_data.SetModify();
    UpdateTitleBar();
    ReDraw();
    EnableDisableRootControls(false);
  }
	
} // OnEditDeleteroot

// ---------------------------------------------------------------------------------------------------------------------

// OnEditExtendendpoint: Extends End Point, called from Edit Menu
void CRootflyDlg::OnEditExtendendpoint(){ OnButtonExtendEnd(); } // OnEditExtendendpoint

void CRootflyDlg::OnEditRegister(){ OnButtonRegister(); }

void CRootflyDlg::OnEditCopyfromprevious(){ OnCopyPrevious(); }

