/* 
* Rootfly:  A program for analyzing and measuring roots. 
* Copyright (c) 2005 Clemson University.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or (at
* your option) any later version.
* 
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 

// mmConversion.cpp : implementation file
//

#include "stdafx.h"
#include "rootfly.h"
#include "mmConversion.h"
#include "Image.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// mmConversion dialog


mmConversion::mmConversion(float conv_val, CWnd* pParent /*=NULL*/)
	: CDialog(mmConversion::IDD, pParent)
{
	//{{AFX_DATA_INIT(mmConversion)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_conversion_value = conv_val;
}


void mmConversion::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(mmConversion)
	DDX_Control(pDX, IDC_EDIT1, m_value);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(mmConversion, CDialog)
	//{{AFX_MSG_MAP(mmConversion)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// mmConversion message handlers

BOOL mmConversion::OnInitDialog() 
{
  CDialog::OnInitDialog();
  CString temp;
  temp.Format("%.2f", m_conversion_value);
  m_value.SetWindowText(temp);

  return TRUE;  // return TRUE unless you set the focus to a control
                // EXCEPTION: OCX Property Pages should return FALSE
}

void mmConversion::OnOK() 
{
  CString temp;
  m_value.GetWindowText(temp);
  if(temp.IsEmpty())
    m_conversion_value = 1.0;
  else
    m_conversion_value = atof(temp);

  CDialog::OnOK();
}

void mmConversion::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
  blepo::ImgBgr img;
  blepo::Load("C:/stb/cvs-local/class/rootfly/data/root_collection/exp_01A_01_01.bmp", &img);
//  CClientDC dc(this);
  blepo::Draw(img, dc, 0, 0);
	
	// Do not call CDialog::OnPaint() for painting messages
}
